	implicit double precision (a-h,o-z)
	parameter (mpoin=10000)
	parameter (melem=10000)
	parameter (mdgof=20000)
	parameter (mprof=10000)
	parameter (mnode=10000)
	parameter (mgaus=8)
	parameter (mmats=10)
	parameter (mbpel=1000)
	parameter (melem2=50000)
	parameter (mpoin2=50001)
	parameter (mdime=3)
	parameter (mnum=1000)
c
c	character*80 title
c	character*10 eltyp
c
c	Dimensions nodal arrays, elemental arrays; degree of freedom
c	arrays and material propeties vector.
c
	dimension x(2,mpoin),icode(mpoin),ldgof(3,mpoin),dispprev(mdgof)
	dimension lnods(2,melem),matno(melem),pressglobal(2,mbpel),
	&		  press(2,mbpel),lbnod(2,mbpel),xkelem(6,6,melem)
     	dimension stifd(mdgof),stifp(mprof),kprof(mdgof),eload(mdgof),
	&		  displ(mdgof),react(mdgof),pdisp(mdgof)
	dimension props(8,mmats),gravt(3),matyp(mmats)
c
c	Dimensions for the adaptivity scheme
c
      dimension xelem(2,mpoin2),icode2(mpoin2),ldgof2(3,mpoin2)
	dimension lnods2(2,melem2),press2(2,melem2),eload2(mdgof),
	&		  react2(mdgof),pdisp2(mdgof),xkelem2(6,6,melem)
	dimension displ2(mdgof),matno2(melem2),effort(3,2,melem)
	dimension effort2(3,2,melem),effort3(3,2,melem),
	&		  effortlocal(3,2,melem),effortlocal2(3,2,melem)
c
	dimension datload(4,mpoin),chi(mnum),
	&		  effort4(3,2,melem),delta(mdgof),er(mdgof)
	dimension xcoorv(mpoin),fload(3,mpoin),lbnodload(2,mpoin),
	&		  floadglobal(3,mpoin),ldgofprev(3,mpoin),n(melem)
c
c
c	Tolerances and other parameters

c	iterations to control displacements
c	
      mitter=2000000
	mitter2=10

	gamma=0.d0
	gammaold=0.d0

	tol1=0.5e-7
	tol2=0.5e-3
c
c	Element information
c	
c	number of degrees of freedom per node
c
	ndime=3
c
c	number of element nodes
c
	nnode=2 
	nnodb=2
c	number of Gauss points
	ngaub=2
c
c
      open(unit=1,file='beam.dat',err=99)
	open(unit=2,file='beam.res',err=20)
	open(unit=3,file='prov.res',err=30)
c
c	1- Reads in the initial nodal positions and boundary codes; 
c	determines the element type to use and reads in the element 
c	connectivities.
c
	call innodes(mpoin,ndime,npoin,x,icode,ldgof)
	call inelems(melem,nelem,nnode,lnods,matno,nmats,n)
c

c	2- Obtains degree of freedom numbers and profile information
c	in an optimum manner, by first finding the node to node
c	connections, then numbering the degrees of freedom following the node
c	to node connections and finaly finds the profile addresses.
c
	call nodecon(npoin,nelem,nnode,lnods,stifp)
	call degfrm(mdgof,npoin,ndime,stifp,ndgof,negdf,ldgof,stifd)
	call profile(mprof,ndgof,nelem,nnode,ndime,lnods,ldgof,
	&			 nprof,kprof)

c     3- Reands in the external loads and prescribed displacements; the
c	material parameters and the iteration control information.
c
c	
	call matprop(nmats,matyp,props)
      call inloads(ndime,npoin,ndgof,negdf,nnodb,mbpel,ldgof,
	&		 eload,pdisp,gravt,nprs,nbpel,lbnod,press,react,x,
     &		 nplsi,effort,lnods,nelem,xloadNx,yloadNy,datload,nplsd,
     &		 xcoorv,fload,lbnodload,pressglobal,floadglobal)
	
c
c	Iterations couter
c
	icounter=0
c
c	4- Works out the external nodal loads for distributed loads
c
   17	call bpress(ndime,nnodb,ngaub,nbpel,lbnod,press,
	&		    ldgof,eload,react,x,lnods,effort,nelem)
c
c	5- We keep the nodal components due to the external forces
c	because we need them in order to work out the external 
c	plastic work
c
	do ig=1,nelem
		do jg=1,2
			do kg=1,ndime
				effort4(kg,jg,ig)=-effort(kg,jg,ig)
			enddo
		enddo
	enddo
c
c	6- Initializes elemental values, obtains element forces and
c	the initial stiffness matrix
c
	call initno(ndgof,nprof,stifd,stifp,displ,icounter)
c
c	7- Itterative loop to solve for the displacements
c
	Do iter=1,mitter
c
		call stiffm(ndime,nnode,nelem,x,lnods,matno,matyp,
	&				props,ldgof,kprof,stifd,stifp,displ,xkelem,
     &				ndgof,nprof)
	
c
c	Solves the equations to find the displacements 
c
		call datri(stifp,stifp,stifd,kprof,ndgof,.false.,6)
	
		call dasol(stifp,stifp,stifd,eload,displ,kprof,ndgof,6,enrg)
	
c
c	 Conjugated Gradient method
c

c
c		niter=1
c   2		call prodmatvec(nelem,ndime,lnods,nnode,ldgof,ndgof,
c	&					displ,xkelem,er)
c		do ig=1,ndgof
c			er(ig)=eload(ig)-er(ig)
c	write (6,*) 'er',er(ig)
c	pause
c		enddo
c	
c		R=0.d0
c		R=abs(sqrt(dot(er,er,ndgof))/sqrt(dot(eload,eload,ndgof)))

c	
c		if ((R.gt.tol2).and.(niter.le.mitter2)) then
c
c			call dasol(stifp,stifp,stifd,er,delta,kprof,ndgof,6,enrg)		
c			do ig=1,ndgof
c				write(6,*) 'delta',delta(ig)
c				displ(ig)=displ(ig)+delta(ig)
c			enddo
c			pause
c			niter=niter+1
c			goto 2
c		endif
c	write (6,*) 'R',R,niter
c	pause

c

c
c	Works out the displacements values
c
c	call gradcon(ndgof,lnods,nnode,ldgof,ndime,nelem,
c	&			eload,xkelem,displ)
c
	
      gammaold=gamma
c
      call displace(ndgof,displ,eload,gamma,nnode,xkelem,nelem,
	&			  lnods,ldgof,ndime,R,iter,dispprev,rdespl)
c
	write(2,*)'iter=',iter,'gamma=',gamma
	write (*,*) ' gamma=',gamma,enrg
	gamma1=gamma
c
	if ((abs ((gamma-gammaold)/gamma).lt.tol1).and.
	&	(abs(R).lt.tol2)) then
c
c	We need to keep gamma to work out the gap
c
      gap=gamma
	write(6,*) 'gamma',gamma,R
	pause

	goto 66
	endif
   12	enddo
  	write (*,*) 'Solution not converged.'
	close(2)
	close(1)
	stop
c
   66 call output(nnode,npoin,nelem,displ,ldgof,ndime,icode,
	&			lnods,ndgof,matno)

c
c	Works out the lower bound 
c
c	Solves a limit analisys problem for each element
c	and finds the minimum multiplier among all the elements
c

c
c	1- works out the nodal internal loads in each element
c	When we work out the lower bound we consider one element as an structure
c	then we choose that the local axis coincide with the global ones.
c
c	It is easier to use all the loads in local axis.
c
c	effort3 will keep the efforts of the elements in order to work out 
c	the equilibrium of the element when we work out the lower bound. 
c
      do i=1,nelem
		do j=1,2
			do k=1,ndime
				effort3(k,j,i)=0.0
			enddo
		enddo
	enddo
c
	call eff(ndime,nelem,lnods,ldgof,xkelem,effort,displ,
 	&         gamma,pdisp,nplsi,x,press,lbnod,effortlocal,
     &		 nbpel,effort3,npoin,icode,equil,xloadNx,yloadNy)
	do ig=1,ndgof
		stifd(ig)=0.d0
	enddo
	do ig=1,nprof
		stifp(ig)=0.d0
	enddo
	
c	

	do ie=1,nelem
c
c	2- Works out nodal positions and boundary codes;
c	determines the element connectivities and materials
c	
c	Variable n(i) keeps the number of elements that the element i has been divided
c	in order to work out the lower bound
c
c	Then the process is repeated in the same way as the upper bound was worked out.	
c
c	Divides the element
c
	nelem2=n(ie)
	npoin2=nelem2+1
c
		call innodes2 (ie,x,xelem,ndime,npoin2,nelem2,nnode,lnods,
	&				   ldgof2,icode2,lnods2,n1,n2,icode,npoin)
c
c	3- Creates the vector matno2 which contains the material type
c
		do i=1,nelem2
			matno2(i)=matno(ie)
		enddo
	
c
c
c	4- Obtains degree of freedom numbers and profile information
c	in an optimum manner, by first finding the node to node
c	connections, then numbering the degrees of freedom following the node
c	to node connections and finaly finds the profile addresses.
c
		call nodecon (npoin2,nelem2,nnode,lnods2,stifp)
		call degfrm (mdgof,npoin2,ndime,stifp,ndgof2,negdf2,ldgof2,
	&				 stifd)
		call profile (mprof,ndgof2,nelem2,nnode,ndime,lnods2,ldgof2,
	&				  nprof,kprof)
c
c	5- Element loads and prescribed dsplacements
c		
		call inloads2(ndgof2,negdf2,nnodb,nbpel,nelem2,lbnod,press,
	&        		press2,n1,n2,ndime,eload2,pdisp2,react2,xelem,
     &				effortlocal,ie,ldgof2,npoin2,nbpel2,lnods2,
     &				effort2,effort3,npoin,lbnodload,xcoorv,fload,
     &				nplsi)
		call bpress(ndime,nnodb,ngaub,nbpel2,lnods2,press2,
	&		    ldgof2,eload2,react2,xelem,lnods2,effort2,nelem2)

c
c	6- Initializes elemental values, obtains element forces and
c	the initial stiffness matrix
c
		call initno(ndgof2,nprof,stifd,stifp,displ2,0)
c
c	Itterative loop to solve for the displacements
c
		gamma=0.d0
		gammaold=0.d0
c
		do iter=1,mitter
			call stiffm(ndime,nnode,nelem2,xelem,lnods2,matno2,matyp,
	&				props,ldgof2,kprof,stifd,stifp,displ2,xkelem2,
     &				ndgof2,nprof)
c
c	7- Solves the equations to find the displacements
c
			call datri(stifp,stifp,stifd,kprof,ndgof2,.false.,6)
			call dasol(stifp,stifp,stifd,eload2,displ2,kprof,ndgof2,
	&				   6,enrg)
c
c	 Conjugated Gradient method
c
c		niter=1
c   3		call prodmatvec(nelem2,ndime,lnods2,nnode,ldgof2,ndgof2,
c	&					  displ2,xkelem2,er)
c		do ig=1,ndgof2
c			er(ig)=eload2(ig)-er(ig)
c		enddo
c	
c		R=0.d0
c		R=abs(sqrt(dot(er,er,ndgof2))/sqrt(dot(eload2,eload2,ndgof2)))
c	write (6,*) 'Rfin',R
c	pause

c	
c		if ((R.gt.tol2).and.(niter.le.mitter2)) then
c
c			call dasol(stifp,stifp,stifd,er,delta,kprof,ndgof2,6,enrg)		
c			do ig=1,ndgof2
cc				write (6,*) 'delta',delta(ig)
c				displ2(ig)=displ2(ig)+delta(ig)
c			enddo
c			pause
c			niter=niter+1
c			goto 3
c		endif
c	write (6,*) 'R',R,niter
c	pause

c
c	8- Works out the displacements values and the mutiplier
c
c
c			call gradcon(ndgof2,lnods2,nnode,ldgof2,ndime,nelem2,
c	&					eload2,xkelem2,displ2)
	
		gammaold=gamma
	
c
		call displace(ndgof2,displ2,eload2,gamma,nnode,xkelem2,nelem2,
	&			  lnods2,ldgof2,ndime,R,iter,dispprev,rdespl)
			write(6,*)'iter=',iter,'gamma=',gamma
			write (*,*) ' gamma=',gamma,enrg
c
		if ((abs ((gamma-gammaold)/gamma).lt.tol1).and.
	&		(abs(R).lt.tol2)) then
				if (ie.gt.1) then
					gammalower=min(gamma,gammalower)
				else	
					gammalower=gamma
				endif
c
c
c	Variables used when we work out the equilibrium. Not important. Just for comprobation
c
	xloadNx=0.d0
	yloadNy=0.d0
c
c	9- internal nodal loads
c
      call eff(ndime,nelem2,lnods2,ldgof2,xkelem2,effort2,displ2,
 	&         gamma,pdisp2,nplsi,xelem,press2,lnods2,effortlocal2,
     &		 nbpel2,effort3,npoin2,icode2,equil,xloadNx,yloadNy)
	
      do ig=1,ndgof2
		stifd(ig)=0.d0
	enddo
	do ig=1,nprof
		stifp(ig)=0.d0
	enddo

c	
				goto 60
   			endif
   13		enddo
  	write (*,*) 'Solution not converged.'
	close(3)
      close(2)
	close(1)
	stop
c	
   60 enddo
c
c	Works out the new mesh and starts the proces from the begining
c
c	1-Works out the gap
c
	gap=gap-gammalower

	write (6,*) 'gap',gap,gap/gammalower
	pause    
c
c
c	2- Collapse load convergence
c
	if (abs(gap/gammalower).lt.tol1) then
		write (6,*) 'Collapse load=',gammalower
		goto 30
	endif
c
c	3- Works out an adapted mesh
c   
c
c	We have to work out the external loads in Global axes 
c	in order to be able to use the subroutines bpoin and bpress
c
c
c	4- Detects the elements we are going to divide into more elements
c
c
c	parameter used to find out if the addition of all element gaps is 1
c
      sumcontrib=0.d0
	npoinprev=npoin
	ndgofprev=ndgof

	do i=1,ndime
		do ig=1,npoin
			ldgofprev(i,ig)=ldgof(i,ig)
		enddo
	enddo
c
	do ie=1,nelem
c	write (6,*)'nelem',nelem,ie
c	pause

c	
c	Works out the contribution of each element to the gap
c
	call contrib(ie,matno,matyp,props,lnods,npoin,x,ldgof,displ,
	&			 pdisp,gap,gammalower,effort4,effort,ndime,cont,
     &			 eleng,n1,n2,x1,y1,sinangle,cosangle)
c
c	Controls that the sum of the gaps is 1.d0
c
	
		sumcontrib=sumcontrib + cont
c
c	5- Decides when we divide the element
c
		if (abs(cont).ge.0.01) then
c
c	6- We devide the element into num elements
c
			num=2
c
c	7- Builds all the vectors and matrixes
c	needed to get a thinner mesh
c
c	7.1- Nodal boundary conditions
c
c	The new nodes are 0 in the boudary type
c	
			do i=1,(num-1)
				icode(npoin+i)=0.d0
			enddo
c
c	Divide the element in num elements
c	The numeration of the new nodes incrases towards
c	the local node 2.
c
c
c	Length of the new elements
c
			h=eleng/num

c	
c	7.2-Local coordinates
c
			do i=1,(num-1)
				chi(i)=i*h
			enddo

c
c	Global coordinates (we base them in local node 1)
c
			do j=1,(num-1)
				x(1,npoin+j)=x1+cosangle*chi(j)
				x(2,npoin+j)=y1+sinangle*chi(j)
			enddo
c
c	7.3-Works out the new nodal connectivity lnods
c
c	The positon of the element ie in lnods is know held by the 
c	new element which has one of its nodes in node local 1 of
c	the previous element, so the last new element has  one
c	of its nodes in node local 2 of the previous element.
c
c	It works if the lnods(1,ie) row has the nodal local 1 and 
c	the lnods(2,ie) row has the nodal local 2. Than means than for each
c	element ie --> lnods(2,ie)>lnods(1,ie).
c
			lnods(2,ie)=npoin+1
			lnods(2,nelem+num-1)=n2
c
c	Now we complete the matrix lnods
c
			do i=1,num-1
				lnods(1,nelem+i)=npoin+i
			enddo
c
			do i=1,num-2
				lnods(2,nelem+i)=npoin+i+1
			enddo
	do ig=1,nelem+num-1
		if (lnods(1,ig).gt.lnods(2,ig)) then
			a=lnods(1,ig)
			lnods(1,ig)=lnods(2,ig)
			lnods(2,ig)=a
		endif
	enddo
c
c	7.4-Assign the element props
c
			do i=1,num-1
			matno(nelem+i)=matno(ie)
			enddo
c
c	7.5- Assign the new discretization values 
c
			do i=1,num-1
			n(nelem+i)=n(ie)/num
			enddo
			n(ie)=n(ie)/num
c
c	7.6- Assing the new pressure loads information in global axis
c
			do i=1,nbpel
				n3=lbnod(1,i)
				n4=lbnod(2,i)
	if (((n1.eq.n3).or.(n1.eq.n4)).and.
	&	((n2.eq.n3).or.(n2.eq.n4))) then
c
				lbnod(1,i)=lnods(1,ie)
				lbnod(2,i)=lnods(2,ie)
				do j=1,num-1
					lbnod(1,nbpel+j)=lnods(1,nelem+j)
					lbnod(2,nbpel+j)=lnods(2,nelem+j)
				enddo
				do j=1,num-1
					pressglobal(1,nbpel+j)=pressglobal(1,i)
					pressglobal(2,nbpel+j)=pressglobal(2,i)

				enddo
				nbpel=nbpel+num-1
	endif
			enddo
c
c	7.7- Assing the new point load information in global axis
c
c
			do i=1,nplsi
				n3=lbnodload(1,i)
				n4=lbnodload(2,i)
	if (((n1.eq.n3).or.(n1.eq.n4)).and.
	&	((n2.eq.n3).or.(n2.eq.n4))) then
c
		if (xcoorv(i).eq.-1) then
				lbnodload(1,i)=lnods(1,ie)
				lbnodload(2,i)=lnods(2,ie)
		else
				lbnodload(1,i)=lnods(1,nelem+num-1)
				lbnodload(2,i)=lnods(2,nelem+num-1)
				xcoorv(i)=-1				
		endif						
	endif
			enddo
	
	
	
c
c	7.8- New number of elements and nodes
c
		nelem=nelem+num-1
		npoin=nelem+1
		endif
	enddo
	write (6,*) 'sumcontrib',sumcontrib,'nelem',nelem
	pause

c
c    7.9-  Control that the parameter n() is bigger or equal than num
c	
	do ik=1,nelem
	if (n(ik).lt.num) then
		write(6,*) 'discretization finished,impossible to persuit'
		write (2,*) 'x'
		do ig=1, npoin
		write (2,*) x(1,ig)
		enddo
		write (2,*) 'y'
		do ig=1, npoin
		write (2,*) x(2,ig)
		enddo
      stop
	endif
	enddo
c
c	8- Now we have a new mesh. The proces will be started from the biggining.
c
c	Initialises the degrees of freedom
c
	do ip=1,npoin
		ic=icode(ip)
c		write (6,*)'ic',ip,ic
c		pause
		do id=1,ndime
			ic0=ic
			ic=ic/2
			ldgof(id,ip)=0
			ldgof(id,ip)=ic0-ic*2
c		write(6,*)'ldgof2',ldgof2(id,ip),id,ip
c	pause
		enddo
c	write(6,*) 'ld',ldgof2(1,ip),ip
c	pause
c	pause
      enddo

c
c	Obtains degree of freedom numbers and profile information
c	in an optimum manner, by first finding the node to node
c	connections, then numbering the degrees of freedom following the node
c	to node connections and finaly finds the profile addresses.
c
	call nodecon(npoin,nelem,nnode,lnods,stifp)
	call degfrm(mdgof,npoin,ndime,stifp,ndgof,negdf,ldgof,stifd)
	call profile(mprof,ndgof,nelem,nnode,ndime,lnods,ldgof,
	&			 nprof,kprof)
c
c	8.1- Nodal point loads
c
	call inloads3(eload,react,datload,ndgof,negdf,nplsd,ldgof,
 	&			  ndime,effort,nelem,npoin,xcoorv,floadglobal,
     &			  lbnod,lbnodload,lnods,nplsi,x,nnodb,press,
     &			  nbpel,pressglobal,fload)
c
c	8.2- We want to take advantatge from the already worked out displ
c	to provide a better initial gess to the next mesh
c
	do ig=1,ndgof2
		displ2=0.d0
	enddo
      do ig=1,ndgofprev
		displ2(ig)=displ(ig)
	enddo
	do ig=1,ndgof
		displ=0.d0
	enddo
	do ig=1,npoinprev
c
c	Node ig : new possition in new displ
c
		ig1=ldgof(1,ig)
		ig2=ldgof(2,ig)
		ig3=ldgof(3,ig)
c
c	Node ig : old possition in old displ
c
		ig4=ldgofprev(1,ig)
		ig5=ldgofprev(2,ig)
		ig6=ldgofprev(3,ig)
c
c	Now we assign the correspondent displacements into the 
c	right possition in displ
c
	if (ig1.gt.0) then
		displ(ig1)=displ2(ig4)
      endif
c
	if (ig2.gt.0) then
		displ(ig2)=displ2(ig5)
      endif	
c
	if (ig3.gt.0) then
		displ(ig3)=displ2(ig6)
      endif
c
	enddo
				
	icounter=icounter+1
	goto 17







   30 close(3)
   20	close(2)
   99 close(1)
 
 	stop
	end
c
c--------------------------------------------------------------------------------------------
	subroutine innodes(mpoin,ndime,npoin,x,icode,ldgof)
c--------------------------------------------------------------------------------------------
c
c	Reads inital nodal coordinates
c 
c	mpoin	--> maximum number of nodes
c	ndime	--> number of dimensions
c	npoin	--> number of points
c	x		--> nodal coordinates
c	icode	--> boundary codes: 
c
c
c
c							   0: free x, y and theta
c							   1: x fixed
c							   2: y fixed
c							   3: x and y fixed
c							   4: theta fixed	
c							   5: x and theta fixed
c							   6: y and theta fixed
c							   7: x, y and theta fixed
c
c
c	ldgof	--> boundary code (1 or 0) for each degree of freedom  
c				corresponding to each node. Later degree of freedom
c				numbers for each node.
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension x(2,*),icode(*),ldgof(ndime,*)
c
c	First reads in the total number of nodes 
c
	read(1,*,err=10) npoin
	write(*,*) 'npoint=',npoin
      if(npoin.gt.mpoin) then
		write (6,100) npoin
		stop
	endif
c
c	Reads nodal coordinates and boundary codes
c
	lp=1
	ip=0
	do while (ip.lt.npoin)
		read(1,*,err=10) ip,icode(ip),(x(id,ip),id=1,2)
		do jp=lp+1,ip
			icode(jp)=icode(ip)
			do id=1,2
				x(id,jp)=x(id,jp-1)+(x(id,ip)-x(id,lp))/(ip-lp)
				write(*,*) 'xknew',x(id,jp)
c				pause
			enddo
		enddo
		lp=ip
	enddo
c	do ig=1,npoin
c		write(6,*) 'icode',icode(ig)
c	pause
c	enddo
c
c	Initialises the degree of freedom array ldgof 
c
	do ip=1,npoin
		ic=icode(ip)
c		write (6,*)ip,ic
c		pause
		do id=1,ndime
			ic0=ic
			ic=ic/2
			ldgof(id,ip)=ic0-ic*2
c			write(6,*) id,ldgof(id,ip),icode(ip),ic,ic0
c			pause
		enddo
	enddo
c		pause
c	do ig=1,npoin
c		do j=1,ndime
c			write (6,*) 'ldg',ldgof(j,ig)
c	enddo
c	pause
c	enddo
	return
c
   10	write (6,'(a)')'error reading nodal coordinates'
	stop
c
  100	format('problem dimensions exceed maximum, set mpoin to:',i10)
	end
c
c--------------------------------------------------------------------------------------------
	subroutine innodes2(ie,x,xelem,ndime,npoin2,nelem2,nnode,lnods,
	&					ldgof2,icode2,lnods2,n1,n2,icode,npoin)
c--------------------------------------------------------------------------------------------
c
c	Works out:
c		xelem	--> global coordinates of the new nodes
c		icode2	--> boundary codes
c		ldgof2	--> boundary code (1 or 0) for each degree
c					of freedom
c		lnods2	--> new element conetivity
c	
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension x(2,*),xelem(2,npoin2),lnods(nnode,*),
	&		  chi(npoin2),icode2(npoin2),ldgof2(ndime,npoin2),
	&		  lnods2(nnode,nelem2),icode(npoin),unit(2),xvect(2)
c
c
c
c	Initialises vectors
c
c
      do i=1,npoin2
		chi(i)=0.d0
		icode2(i)=0
		do j =1,2
			xelem(j,i)=0.d0
		enddo
		do j =1,ndime
			ldgof2(j,i)=0
		enddo
	enddo

c	Find member coordinates
c
	n1=lnods(1,ie)
	n2=lnods(2,ie)
c  	
      if (n1.gt.n2) then
		a=n1
		n1=n2
		n2=a
	endif
c
   	x1=x(1,n1)
	y1=x(2,n1)
	x2=x(1,n2)
	y2=x(2,n2)
c
c	Find the element length
c
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
c	Works out the angle between local x and global X
c
c	Not useful anymore can be deleted
c
	unit(1)=1.d0
	unit(2)=0.d0
	xvect(1)=x2-x1
	xvect(2)=y2-y1
	angle=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
c	Sin and Cos....very useful....relations global and local axis.
c
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
c	Creation of the mesh of one element. Mesh that will be used
c	to work out the load multiplier for the element.
c
c	Divide the element in nelem2 elements
c
	h=eleng/nelem2
c	
c	Local coordinates
c
	do i=1,npoin2
		chi(i)=(i-1)*h
      enddo

c

c
c	Global coordinates
c
      do j=1,npoin2
		xelem(1,j)=(j-1)*h
		xelem(2,j)=0.d0
	enddo

c
c	Degrees of freedom. Be carefull here...it depends on the dimension of the problem
c
c	The elements must have isostatic conditions.
c

		icode2(1)=3
		icode2(npoin2)=2
c
c	Initialises the degrees of freedom
c
	do ip=1,npoin2
		ic=icode2(ip)
c		write (6,*)'ic',ip,ic
		do id=1,ndime
			ic0=ic
			ic=ic/2
			ldgof2(id,ip)=ic0-ic*2
		enddo
      enddo

c
c	New matrix of connectivities 
c
	do j=1,nelem2
		lnods2(1,j)=j
		lnods2(2,j)=j+1
	enddo
c
	return
	end
c
c--------------------------------------------------------------------------------------------
	subroutine inelems(melem,nelem,nnode,lnods,matno,nmats,n)
c--------------------------------------------------------------------------------------------
c
c	Read in the element connectivities
c
c	melem	-->	maximum number of elements
c	nelem	-->	number of elements
c	nnode	-->	number of nodes per element
c	lnods	-->	nodal conectivities of dimensions (nnode,nelem)
c	matno	-->	material number of each element
c	nmats	-->	number of materials
c	n(i)	--> number of elements that element i will be divided when working 
c				out the lower bound 
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lnods(nnode,*),matno(*),n(*)
c
c	First reads the number of elements 
c
	read(1,*,err=10) nelem
	if(nelem.gt.melem) then
		write (6,100) nelem
		stop
	endif
c
c	Reads in element connectivities and material types
c	Also reads the number of elements n(i) that element i
c	will be divided when working out the lower bound.
c
	nmats=0 
      ie=0
	le=1
	inc=0
	do while(ie.lt.nelem)
		read(1,*,err=10) ie,matno(ie),n(ie),(lnods(in,ie),in=1,nnode)
		if (lnods(1,ie).gt.lnods(2,ie)) then
			a=lnods(1,ie)
			lnods(1,ie)=lnods(2,ie)
			lnods(2,ie)=a
		endif
     		nmats=max(nmats,matno(ie))
		if(inc.eq.0) inc=1
		do je=le+1,ie-1
			matno(je)=matno(le)
			do in=1,nnode
				lnods(in,je)=lnods(in,je-1)+inc
			enddo
		enddo
		le=ie
	enddo
c	do ig=1,nelem
c		do i=1,2
c	write (6,*) 'lnods',lnods(i,ig)
c	enddo
c	pause
	return
c
   10	write(6,'(a)') 'Error reading element connectivities'
	stop
  100	format ('problem dimensions exceed maximum,set melem to:',i10)
	end
c
c--------------------------------------------------------------------------------------------
	subroutine nodecon(npoin,nelem,nnode,lnods,nconn)
c--------------------------------------------------------------------------------------------
c
c	Determines the node to node connectivities and stores them 
c	in nconn as a linked list 
c	
c	npoin	--> number of mesh nodes
c	nelem	-->	number of elements
c	nnode	--> number of nodes per element
c	lnods	-->	element nodal connectivities
c	nconn	--> nodal connectivitis as a linked list of
c				dimension (2,total number of node to node connexions):
c
c				/ number of nodes connected to node 1,..../
c				/ position of next node connected to 1,.../
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lnods(nnode,*),nconn(2,*)
c
c	Initialises the matrix nconn to zero and sets the first free position 
c	in nconn to npoin+1
c
	do ip=1,npoin
		nconn(1,ip)=0
		nconn(2,ip)=0
	enddo
	nfree=npoin+1
c
c	Loop over the elements to examine all nodal connexions
c
	do ie=1,nelem
		do in=1,nnode
			ip=lnods(in,ie)
			do jn=1,nnode
				jp=lnods(jn,ie)
				if(jp.ne.ip) then
c
c	Node jp es connected to node ip. Jumps along the linked list
c	until no more connections are found
c
					naddr=nconn(2,ip)
					nadd0=ip
					do while (naddr.gt.0)
						kp=nconn(1,naddr)
						if (kp.eq.jp) goto 10
							nadd0=naddr
							naddr= nconn(2,nadd0)
					enddo
c
c	Puts the new node jp as a connection to ip and creates a new cell
c	in the link list at position nfree
c
					nconn(2,nadd0)=nfree
					nconn(1,nfree)=jp
					nconn(2,nfree)=0
					nconn(1,ip)=nconn(1,ip)+1
					nfree=nfree+1
   10				endif
			enddo
		enddo
	enddo
c	do j=1,nfree
c	write(6,*) j,(nconn(i,j),i=1,2)
c	pause
c   	enddo
      return
	end
c
c
c--------------------------------------------------------------------------------------------
	subroutine degfrm(mdgof,npoin,ndime,nconn,ndgof,negdf,ldgof,ndque)
c--------------------------------------------------------------------------------------------
c	Determines the profile solver information, in particular degrees
c	of freedom corresponding to each node.
c	The degreee of freedom numbering is performed in such a way
c	that the profile size is reasonable.
c
c	mdgof	--> maximum number of degrees of freedom allowed
c	npoin	--> number of points
c	ndime	--> number of dimensions
c	nconn	--> node to node connectivity array
c	ndgof	--> number of degrees of freedom
c	negdf	-->	number of fixed degrees of freedom
c	ldgof	--> degrees of freedom of each node, array of dimensions
c				(ndime,npoin)
c	ndque	--> circular queue, storing next nodes' degrees of freedom to number
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension nconn(2,*),ldgof(ndime,*),ndque(*)
c
c	Initialize the queue by puting node 1 in it.
c	numbn	--> number of nodes already dealt with
c
c	do ip=1,npoin
c		write (6,*) ip, ldgof(1,ip), ldgof(2,ip)
c	enddo							 
c
	ndque(1)	= 1
	nconn(1,1)	= 0
	lqbeg		= 1
	lqend		= 1
	numbn		= 0
	ndgof		= 0
	negdf		= 0
c	
c	Loops while there are points to be numbered. If the queue is empty 
c	finds the first node unnumbered
c
	do while (numbn.lt.npoin)
2		if(lqend.lt.lqbeg) then
			ip=2
			do while (nconn(1,ip).le.0)
				ip=ip+1
			enddo
c
c	Otherwise takes the first node in the queue and removes it from
c	the queue
c
		else
			lqb		= 1+mod(lqbeg-1,npoin)
			ip		= ndque(lqb)
			lqbeg	= lqbeg+1
c		write(6,*) lqb,ip,lqbeg
c	    pause
		endif
		numbn		= numbn+1
c
c	Adds nodes connected to ip to the queue
c
		naddr = nconn(2,ip)
		do while (naddr.gt.0)
			jp		= nconn(1,naddr)
			naddr	= nconn(2,naddr)
			if(nconn(1,jp).gt.0) then
				lqend		= lqend+1
				lqe			= 1 + mod(lqend-1,npoin)
				ndque(lqe)	= jp
				nconn(1,jp)	= 0
			endif
		enddo
c
c	Defines the degree of freedom numbers for node ip. If fixed sets
c	the corresponding positions to 0.
c
		do id=1,ndime
			if(ldgof(id,ip).eq.0) then
				ndgof		= ndgof+1
				ldgof(id,ip)= ndgof
			else
				negdf		=negdf+1
				ldgof(id,ip)= -negdf
			endif
		enddo
	enddo
c
c	Checks that the total number of degrees of freedom is OK
c		
	if (ndgof.gt.mdgof) then
		write(6,100) ndgof
	endif
c	write(6,*)'ndgof',ndgof	,'negdf',negdf
c	pause
c
	return
  100	format('problem dimensions exceed maximum, set mdgof to:',i10)
	end
c
c--------------------------------------------------------------------------------------------
	subroutine profile(mprof,ndgof,nelem,nnode,ndime,lnods,ldgof,
	&					nprof,kprof)
c--------------------------------------------------------------------------------------------
c
c	Determines the profile solver information, in particular profile
c	heights and then profile addresses.
c
c	mprof	--> maximum number of degrees of freedom alowed
c	nelem	--> number of elements
c	ndime	--> number of dimensions
c	nnode	--> number of nodes per element
c	ndgof	--> number of degrees of freedom
c	lnods	--> element connectivities
c	ldgof	--> degrees of freedom of each node, array of dimensions
c				(ndime,npoin)
c	nprof	--> number of entries in the out of diagonal part of K
c	kprof	--> first heigt of each profile column, then address in
c				stifp of each column
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension ldgof(ndime,*),kprof(*),lnods(nnode,*)
c
c	Initialise kprof to 0
c
	do ig=1,ndgof
		kprof(ig)=0
	enddo
c
c	Loops over each element and first finds the lowest degree of freedom	
c	in that element (lg)
c
	do ie=1,nelem
c		lg=5**5
		lg=ndgof
		do in=1,nnode
			ip=lnods(in,ie)
			do id=1,ndime
				ig=ldgof(id,ip)
				if(ig.gt.0) lg=min(lg,ig)
			enddo
		enddo
c
c	Then finds the difference between other degrees of freedom in the
c	element and lg
c
		do in=1,nnode
			ip=lnods(in,ie)
			do id=1,ndime
				ig=ldgof(id,ip)
				if(ig.gt.0) kprof(ig)=max(kprof(ig),ig-lg)
			enddo
		enddo
	enddo
c
c	Transforms the heigt informations into addresses af each column in
c	stifp, by simply accumulating the heigts of each column. Also finds
c	the total number of spaces need to restore stifp
c
	kprof(1)=0
	do ig=2,ndgof
		kprof(ig)=kprof(ig)+kprof(ig-1)
c	write (6,*) 'kprof',ig,kprof(ig)
c	pause
	enddo
	nprof=kprof(ndgof)
c
c	Checks that tere is enough storage alocatted  to stifp
c	
c	do j=1,21 
c	write(6,*)'ldgof',(ldgof(i,j),i=1,2)
c	pause
c      enddo
c	do j=1,61
c	write(6,*)nconn(1,1)
c	pause
c	enddo
c   	   
     	if(nprof.gt.mprof) then
		write (6,100) nprof
		stop
	endif
	return
	
c
  100	format('problem dimensions exceed maximum,set mprof to:',i10)
	end
c
c--------------------------------------------------------------------------------------------
	subroutine matprop(nmats,matyp,props)
c--------------------------------------------------------------------------------------------
c
c	Reads in the material type and material propeties. Also
c	re-arranges the propeties to save tive later on
c
c	ndime	--> number of dimensions
c	matyp	--> material type
c	props	--> vector of propeties
c
c	/ ----------/----------/----------/----------/----------/----------/----------/
c	/  material / props(1) / props(2) / props(3) / props(4) / props(5) / props(6) /
c	/ ==========/==========/==========/==========/==========/==========/==========/
c	/	 1	   / density  /	   fy	 /	 eps	/  xarea   /	-	  /		-	 /
c	/ ----------/----------/----------/----------/----------/----------/----------/
c	/	 2	   / density  /	   fy	 /	 eps	/  xarea   /	-	  /		-	 /
c	/ ----------/----------/----------/----------/----------/----------/----------/
c
c	Material types:

c		1	--> material 1 in truss
c		2	--> material 2 in truss
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension props(8,*), matyp(*)
c
c	First makes sure that the number of materials coincides with the
c	number obtained form element information
c
	read(1,*,err=10) nmat2
c	write (6,*) nmat2,nmats
c	pause
	if(nmat2.ne.nmats) goto 10
c	pause
c
c	Loops over al the material types
c
	do jm=1,nmats
		read(1,*,err=10) im,matyp(im) 
c
c    Check that the material is implemented and re-arranges parameters
c	
		if(matyp(im).eq.1) then
			read(1,*,err=10) props(1,im),props(2,im),props(3,im),
	&						 props(4,im)
		else if(matyp(im).eq.2) then
			read(1,*,err=10) props(1,im),props(2,im),props(3,im),
	&						 props(4,im)
		else if(matyp(im).eq.3) then
			read(1,*,err=10) props(1,im),props(2,im),props(3,im),
	&						 props(4,im)
		endif
	enddo
c	do jm=1,nmats
c		write(6,*) props(1,jm),props(2,jm),props(3,jm),
c	&						 props(4,jm)
c     pause
c	enddo 
	return
c
   10	write(6,'(a)') ' error reading material properties'
      stop
c
  101 format('Material type not implemented:',i3)
  102 format('Wrong material for number of dimensions')
	end
c
c--------------------------------------------------------------------------------------------
	subroutine inloads(ndime,npoin,ndgof,negdf,nnodb,mbpel,ldgof,
	&				   eload,pdisp,gravt,nprs,nbpel,lbnod,press,
     &				   react,x,nplsi,effort,lnods,nelem,xloadNx,
     &				   yloadNy,datload,nplsd,xcoorv,fload,lbnodload,
     &				   pressglobal,floadglobal)
c--------------------------------------------------------------------------------------------
c
c	Reads inload and prescribed positions
c
c	ndime	--> number of dimensions
c	npoin	--> number of points
c	ndgof	--> number of degrees of freedom
c	negdf	--> number of fixed degrees of freedon
c	nnodb	--> number of nodes per boundary element
c	mbpel	--> maximum number of boundary pressure elements
c	ldgof	--> array containing the degrees of freedom of each node or
c				0 for fixed nodes. If the coordinate of these fixed
c				nodes is to be prescribed, the number sotree will be
c				-(the prescribed condition number)
c	eload	--> external load on each degree of freedom
c	pdisp	--> prescribed positions of fixed nodes
c	gravt	--> gravity acceleration vector
c	npsr	--> number of prescribed displacements
c	nbpel	--> number of boundary pressure elements
c	lbnod	--> pressure elements connectivity matrix
c	press	--> applied pressures
c	nplsi	--> number of point loads (not nodal)
c	effort  --> now keeps the exernal nodal loads....then will keep the internal loads
c	x		--> element coordinates
c	react	--> element reactions, now it keeps the external nodal loads...then will keep the reactions

c     fload   --> keeps point loads values
c	lb
c	
c	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension ldgof(ndime,*),eload(*),pdisp(negdf),gravt(2),
	&		  press(2,*),lbnod(nnodb,*),react(*),x(2,*),
	&		  force(3),effort(3,2,nelem),lnods(nnodb,nelem),
	&		  datload(4,npoin),xcoorv(npoin),fload(ndime,npoin),
     &		  lbnodload(nnodb,npoin),xvect(2),unit(2),
     &		  pressglobal(2,*),floadglobal(ndime,*)
c
c	Reads the number of points loads, prescribed displacements and gravity vector
c
c
      read(1,*,err=10) nplsd,nplsi,nprs,nbpel,gravt
c
c	Initialises the force vector,prescribed displacements and reactions
c
	do ig=1,ndgof
		eload(ig)=0.d0
	enddo
	do ig=1,negdf
		pdisp(ig)=0.d0
	enddo
	do id=1,negdf
		react(id)=0.d0
	enddo
	do i=1,nelem
		do j=1,2
			do k=1,ndime
				effort(k,j,i)=0.d0
			enddo
		enddo
	enddo
c
c	1- Reads Nodal loads in global axes and allocates them accordingly
c	If there is a load in a support the reaction must keep its value
c
c	force	--> auxiliar vector used to read the nodal point loads
c	datload --> Keeps the information about the point loads

	xloadNx=0.d0
	yloadNy=0.d0
	do il=1,nplsd
		read(1,*,err=10) ip, (force(id),id=1,ndime)
c		write(6,*) 'ip',ip,(force(id),id=1,ndime)
c	pause
c
c	the load information is kept to be used when refining the mesh. We will
c	need this information in order to assemble the new external load vector
c
		datload(1,il)=ip
		datload(2,il)=force(1)
		datload(3,il)=force(2)
		datload(4,il)=force(3)
c
c		This is used to work out the element equilibrium
c		It can be deleted
c
		xloadNx=xloadNx+force(1)
		yloadNy=yloadNy+force(2)
c
c		Assembles the nodal point loads	to the load vector
c
		if(ip.gt.npoin) goto 10
		do id=1,ndime
			ig=ldgof(id,ip)
			if(ig.gt.0) then 
				eload(ig)=eload(ig)+force(id)
			else
				react(-ig)=react(-ig)-force(id)
			endif
		enddo
	enddo
c
c	2- Reads point loads in global axes (not nodal) within the elements and
c	assembles the nodal forces to eload
c
c	ii		---> 1,2,3,4...
c	ik		---> element node
c	ip		---> element node
c	xcoor	---> coordinate of the point load  between(-1,1)
c				-1 corresponds to node 1(local)
c				 1 corresponds to node 2(local)
c	load(1) ---> Force
c	load(2) ---> Moment
c	nplsi	---> Number of point (forces,moments)
c	lbnodload --> auxiliar vector to read the loads
c	floadglobal --> loads in global axis
c	fload	--> loads in local axis
c
c
	do ili=1,nplsi
		read(1,*,err=10) ii,(lbnodload(i,ii),i=1,nnodb),xcoorv(ii),
	&					(fload(id,ii),id=1,ndime)
		floadglobal(1,ii)=fload(1,ii)
		floadglobal(2,ii)=fload(2,ii)
c
c	We pass the read loads into local axis
c
c
	ik=lbnodload(1,ii)
	ip=lbnodload(2,ii)
      if(ik.gt.ip) then
	a=ik
	ik=ip
	ip=a
	endif
c
      x1=x(1,ik)
	y1=x(2,ik)
	x2=x(1,ip)
	y2=x(2,ip)
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c   	
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c
c
c	Cos and Sin of the anlgle between local and global axis
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
c	auxiliar variables
c
	z=fload(1,ii)
	y=fload(2,ii)
c	
      fload(1,ii)=z*cosangle+y*sinangle
	fload(2,ii)=-z*sinangle+y*cosangle
c
c	write(6,*) 'inloads,fload', fload(1,ii),fload(2,ii),fload(3,ii)
c	pause
c
c	Now the point loads are assembled to the loads vector
c
	call bpoin(x,xcoorv(ii),fload(1,ii),lbnodload(1,ii),
	&				lbnodload(2,ii),
	&				ldgof,ndime,eload,
	&				react,nelem,lnods,effort)
	enddo
c
c	3- Reads in prescribed displacements. This must applied to only
c	fixed degrees of freedom
c	WATCH OUT....IS HAS NOT BEEN IMPLEMENTED
c
	do i=1,nprs
		read(1,*,err=10) ip,id,presc
		if(ip.gt.npoin) goto 10
		il=ldgof(id,ip)
		if(il.gt.0) goto 10
		pdisp(-il)=presc
	enddo
c
c	4- Reads in pressure elements in global axis
c
c		pressglobal	--> distributed loads in global axis
c		press		--> distributed loads in local axis
c		
	if(nbpel.eq.0) return
	if(nbpel.gt.mbpel) goto 10
	do ie=1,nbpel
		read(1,*,err=10) je,(lbnod(i,je),i=1,nnodb),
	&					(press(i,je),i=1,2)
		pressglobal(1,je)=press(1,je)
		pressglobal(2,je)=press(2,je)
		if (lbnod(1,ie).gt.lbnod(2,ie)) then
			a=lbnod(1,ie)
			lbnod(1,ie)=lbnod(2,ie)
			lbnod(2,ie)=a
		endif
c		write(6,*) je,(lbnod(i,je),i=1,nnodb),press(je)  
c      	pause
c
c	We pass the read loads into local axis
c
c
	ik=lbnod(1,je)
	ip=lbnod(2,je)
c
      x1=x(1,ik)
	y1=x(2,ik)
	x2=x(1,ip)
	y2=x(2,ip)
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c   	
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
	z=press(1,je)
	y=press(2,je)
c	
      press(1,je)=z*cosangle+y*sinangle
	press(2,je)=-z*sinangle+y*cosangle
	enddo
	return
c
   10 write(6,'(a)') 'error reading nodal forces'
	stop
	end
c
c--------------------------------------------------------------------------------------------
	subroutine inloads2(ndgof2,negdf2,nnodb,nbpel,nelem2,lbnod,press,
	&					press2,n1,n2,ndime,eload2,pdisp2,react2,xelem,
     &					effortlocal,ie,ldgof2,npoin2,nbpel2,lnods2,
     &					effort2,effort3,npoin,lbnodload,xcoorv,fload,
     &					nplsi)
c--------------------------------------------------------------------------------------------
c
c	Assemble the loads for the case of the lower bound. Then it assembles the internal loads and
c	external loads to the load element vector in order to find the load multiplier for this element
c
c	It is considered that the local and global axis coincide.
c
c	lbnod	--> conectivity of the elements which have pressuere acting on them 
c	press	--> distributed loads in local axis
c	press2	--> keeps the distributed load for the knew elements
c
c
c
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lbnod(nnodb,*),press(2,*),press2(2,*),eload2(*),
	&		  pdisp2(*),xelem(2,npoin2),
     &		  fload2(3),ldgof2(ndime,nelem2),react2(*),
	&		  lnods2(2,nelem2),effort2(3,2,nelem2),
     &		  effort3(3,2,nelem2),xcoorv(npoin),fload(ndime,npoin),
	&		  lbnodload(nnodb,npoin),effortlocal(3,2,*)
c
c	Initialises the force vector,prescribed displacements and reactions
c

	do ig=1,ndgof2
		eload2(ig)=0.0
	enddo
	do ig=1,negdf2
		pdisp2(ig)=0.0
	enddo
	do id=1,negdf2
		react2(id)=0.0
	enddo
	do i=1,nelem2
		do j=1,2
			do k=1,2
				effort2(k,j,i)=0.0
			enddo
		enddo
	enddo
c
c	Assemblement of internal loads
c
c	Reads point loads (not nodal) within the elements and
c	assembles the nodal forces to eload
c
c	
c	ik		---> element node
c	ip		---> element node
c	xcoor	---> coordinate of the point load  between(0,1)
c				 0 corresponds to node 1(local)
c				 1 corresponds to node 2(local)
c	load(1) ---> Force
c	load(2) ---> Moment
c	nplsi	---> Number of point (forces,moments)
c
c	First assembles the internal load of node 1(local) of the element (n1,n2)
c
		ik=1
		ip=2
		xcoor=-1.0
		do id=1,ndime
			fload2(id)=effortlocal(id,1,ie)
		enddo
		call bpoin(xelem,xcoor,fload2,ik,ip,ldgof2,ndime,eload2,
	&			   react2,nelem2,lnods2,effort2)

c
c	Assembles the internal load of node 2 (local) of the element (n1,n2)
c
      	ik=npoin2-1
		ip=npoin2
		xcoor=1.0
		do id=1,ndime
			fload2(id)=effortlocal(id,2,ie)
		enddo
		call bpoin(xelem,xcoor,fload2,ik,ip,ldgof2,ndime,
	&	eload2,react2,nelem2,lnods2,effort2)
c
c	In order to work out the equilibrium we keep the nodal
c	internal loads	of each previous element
c
	do i=1,nelem2
		do j=1,2
			do k=1,3
				effort3(k,j,i)=-effort2(k,j,i)
			enddo
		enddo
	enddo
c
c	Point loads in elements (only in the nodes of the element)
c
c	

	do ig=1,nplsi
		n3=lbnodload(1,ig)
		n4=lbnodload(2,ig)
c	write(6,*) 'n1',n1,n2,n3,n4
c	pause
c
c	First detect the elements that have point loads
c
	if(((n1.eq.n3).or.(n1.eq.n4)).and.((n2.eq.n3).or.(n2.eq.n4))) then		
c	
c	Then assembles the loads
c	
		if(xcoorv(ig).eq.1) then
		call bpoin(xelem,xcoorv(ig),fload(1,ig),npoin2-1,npoin2,
	&				ldgof2,ndime,eload2,
	&				react2,nelem2,lnods2,effort2)
		endif
c		
		if(xcoorv(ig).eq.-1) then
		call bpoin(xelem,xcoorv(ig),fload(1,ig),1,2,
	&				ldgof2,ndime,eload2,
	&				react2,nelem2,lnods2,effort2)
		endif
	endif
	enddo			
c
c	Distributed loads
c
c	First detects if the element has pressure
c
c	Then keeps the value of the pressure
c
	nbpel2=0
      do i=1,nbpel
		n3=lbnod(1,i)
		n4=lbnod(2,i)
	if(((n1.eq.n3).or.(n1.eq.n4)).and.((n2.eq.n3).or.(n2.eq.n4))) then
			do j=1,nelem2
				do jk=1,2
			press2(jk,j)=press(jk,i)
				enddo
			enddo
			nbpel2=nelem2
	endif
	enddo

	return
	end
c
c--------------------------------------------------------------------------------------------
	subroutine inloads3(eload,react,datload,ndgof,negdf,nplsd,ldgof,
	&					ndime,effort,nelem,npoin,xcoorv,floadglobal,
     &					lbnod,lbnodload,lnods,nplsi,x,nnodb,press,
     6					nbpel,pressglobal,fload)
c--------------------------------------------------------------------------------------------
c	Assembles the loads for the new mesh after the refinement step.
c
c--------------------------------------------------------------------------------------------

c
	implicit real*8 (a-h,o-z)
	dimension eload(ndgof),react(negdf),datload(3,*),ldgof(ndime,*),
	&		  effort(3,2,nelem),xcoorv(nplsi),fload(ndime,nplsi),
	&		  lbnodload(nnodb,nplsi),lnods(nnodb,nelem),x(2,npoin),
	&		  press(2,*),lbnod(2,nbpel),floadglobal(ndime,nplsi),
	&		  pressglobal(2,*),unit(2),xvect(2)
c
c
	do ig=1,ndgof
		eload(ig)=0.d0
	enddo
	do id=1,negdf
		react(id)=0.d0
	enddo
	do i=1,nelem
		do j=1,2
			do k=1,ndime
				effort(k,j,i)=0.d0
			enddo
		enddo
	enddo
c
c	We pass the loads into local axes
c
c
	do je=1,nbpel
	ik=lbnod(1,je)
	ip=lbnod(2,je)
c
      x1=x(1,ik)
	y1=x(2,ik)
	x2=x(1,ip)
	y2=x(2,ip)
c
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c   	
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
	z=pressglobal(1,je)
	y=pressglobal(2,je)
c	
      press(1,je)=z*cosangle+y*sinangle
	press(2,je)=-z*sinangle+y*cosangle
c	
      enddo
c
c	Point loads
c
		
c
	do ili=1,nplsi
	ik=lbnodload(1,ili)
	ip=lbnodload(2,ili)
c
      x1=x(1,ik)
	y1=x(2,ik)
	x2=x(1,ip)
	y2=x(2,ip)
c
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c   	
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng

	z=floadglobal(1,ili)
	y=floadglobal(2,ili)
	fload(1,ili)=z*cosangle+y*sinangle
	fload(2,ili)=-z*sinangle+y*cosangle
     	call bpoin(x,xcoorv(ili),fload(1,ili),lbnodload(1,ili),
	&				lbnodload(2,ili),
	&				ldgof,ndime,eload,
	&				react,nelem,lnods,effort)
	enddo
c
c	Reads Nodal loads and allocates them accordingly
c	If there is a load in a support the reaction must 
c	keep its value
c
	do il=1,nplsd
		ip=datload(1,il)
		if(ip.gt.npoin) goto 11
		do id=1,ndime
			ig=ldgof(id,ip)
			if(ig.gt.0) then 
				eload(ig)=eload(ig)+datload(id+1,il)
			else
				react(-ig)=react(-ig)-datload(id+1,il)
			endif
		enddo
	enddo
	return
c
   11 write(6,'(a)') 'error reading nodal forces'
	stop
	end
c
c--------------------------------------------------------------------------------------------
	subroutine bpoin(x,xcoor,fload,ik,ip,ldgof,ndime,eload,
	&				react,nelem,lnods,effort)
c--------------------------------------------------------------------------------------------
c
c	Evaluates the nodal forces due to point loads within elements
c	and assembles the corresponding component of the tangent matrix
c
c	ii		---> 1,2,3,4...
c	ik		---> element node
c	ip		---> element node
c	xcoor	---> coordinate of the point load  betwen(-1,1)
c	load(1) ---> Force
c	load(2) ---> Moment
c	nplsi	---> Number of point (forces,moments)
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension x(2,nelem),fload(3), ldgof(ndime,*),
	&			eload(*),react(*),lnods(2,nelem),
	&			effort(3,2,nelem),unit(2),xvect(2)
c
c	do ig=1,ndime
c		write (6,*) 'fload', fload(ig)
c	enddo
c	pause
c
c	Finds the length of the element
c
	if(ik.gt.ip) then
	a=ik
	ik=ip
	ip=a
	endif
c
      x1=x(1,ik)
	y1=x(2,ik)
	x2=x(1,ip)
	y2=x(2,ip)
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c   	
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng 
c
c	Finds which node is 1 in local numbering
c
c	Local numberig 1 corresponds to the low global numbering
c        dxN1despl(xd,eleng)
     
      ig1=ldgof(1,ik)
	ig2=ldgof(2,ik)
	ig3=ldgof(3,ik)
      ig4=ldgof(1,ip)
	ig5=ldgof(2,ip)
	ig6=ldgof(3,ip)
c
c	We keep the nodal loads due to point loads in elements
c	in Global axes
c
c	
c
c	do k=1,nelem
c		do i=1,2
c			do j=1,2
c	write (6,*) nelem
c     write(6,*) i,j,k,effort(i,j,k)
c	pause
c	enddo
c	enddo
c	enddo
	do it=1,nelem
		n1=lnods(1,it)
		n2=lnods(2,it)
	if(((n1.eq.ik).or.(n1.eq.ip)).and.((n2.eq.ik).or.(n2.eq.ip))) then
c
		effort(1,1,it)=effort(1,1,it)-
	&				   (fload(1)*cosangle*xN5despl(xcoor,eleng)-
     &					fload(2)*sinangle*xN1despl(xcoor,eleng)-
     &					fload(3)*sinangle*dxN1despl(xcoor,eleng))
c		write(6,*) 'effort',effort(1,1,it)
c	pause
c	
		effort(2,1,it)=effort(2,1,it)-
	&				   (fload(1)*sinangle*xN5despl(xcoor,eleng)+
     &					fload(2)*cosangle*xN1despl(xcoor,eleng)+
     &					fload(3)*cosangle*dxN1despl(xcoor,eleng))
c		write(6,*) 'effort',effort(2,1,it)
c	pause
c			
		effort(3,1,it)=effort(3,1,it)-
	&				   (fload(2)*xN2despl(xcoor,eleng)+
     &					fload(3)*dxN2despl(xcoor,eleng))
c		write(6,*) 'effort',effort(1,2,it)
c	pause
c		
		effort(1,2,it)=effort(1,2,it)-
	&				   (fload(1)*cosangle*xN6despl(xcoor,eleng)-
     &					fload(2)*sinangle*xN3despl(xcoor,eleng)-
     &					fload(3)*sinangle*dxN3despl(xcoor,eleng))
c		write(6,*) 'effort',effort(2,2,it)
c	pause
c	
		effort(2,2,it)=effort(2,2,it)-
	&				   (fload(1)*sinangle*xN6despl(xcoor,eleng)+
     &					fload(2)*cosangle*xN3despl(xcoor,eleng)+
     &					fload(3)*cosangle*dxN3despl(xcoor,eleng))
c		write(6,*) 'effort',effort(2,1,it)
c	pause
c			
		effort(3,2,it)=effort(3,2,it)-
	&				   (fload(2)*xN4despl(xcoor,eleng)+
     &					fload(3)*dxN4despl(xcoor,eleng))
c
	endif
	enddo	
      if (ip.gt.ik) then
c
c
c	Node 1
c	Assembles the force corresponding to u(1)
c
  101		if(ig1.gt.0) then
				eload(ig1)=eload(ig1)+
	&				   (fload(1)*cosangle*xN5despl(xcoor,eleng)-
     &					fload(2)*sinangle*xN1despl(xcoor,eleng)-
     &					fload(3)*sinangle*dxN1despl(xcoor,eleng))
     		else
				react(-ig1)=react(-ig1)-
	&				   (fload(1)*cosangle*xN5despl(xcoor,eleng)-
     &					fload(2)*sinangle*xN1despl(xcoor,eleng)-
     &					fload(3)*sinangle*dxN1despl(xcoor,eleng))
		endif
c
c	Assembles the force corresponding to v(1)
c
		if(ig2.gt.0) then
				eload(ig2)=eload(ig2)+
	&				   (fload(1)*sinangle*xN5despl(xcoor,eleng)+
     &					fload(2)*cosangle*xN1despl(xcoor,eleng)+
     &					fload(3)*cosangle*dxN1despl(xcoor,eleng))
		else
				react(-ig2)=react(-ig2)-
	&				   (fload(1)*sinangle*xN5despl(xcoor,eleng)+
     &					fload(2)*cosangle*xN1despl(xcoor,eleng)+
     &					fload(3)*cosangle*dxN1despl(xcoor,eleng))
		endif
c
c	Assembles the force corresponding to theta(1)
c
		if(ig3.gt.0) then
				eload(ig3)=eload(ig3)+
 	&				   (fload(2)*xN2despl(xcoor,eleng)+
     &					fload(3)*dxN2despl(xcoor,eleng))
		else
				react(-ig3)=react(-ig3)-
 	&				   (fload(2)*xN2despl(xcoor,eleng)+
     &					fload(3)*dxN2despl(xcoor,eleng))
		endif
c
c	Node 2
c	Assembles the force corresponding to u(2)
c
   		if(ig4.gt.0) then
				eload(ig4)=eload(ig4)+
 	&				   (fload(1)*cosangle*xN6despl(xcoor,eleng)-
     &					fload(2)*sinangle*xN3despl(xcoor,eleng)-
     &					fload(3)*sinangle*dxN3despl(xcoor,eleng))
		else
				react(-ig4)=react(-ig4)-
 	&				   (fload(1)*cosangle*xN6despl(xcoor,eleng)-
     &					fload(2)*sinangle*xN3despl(xcoor,eleng)-
     &					fload(3)*sinangle*dxN3despl(xcoor,eleng))
		endif
c
c	Assembles the force corresponding to v(2)
c
		if(ig5.gt.0) then
				eload(ig5)=eload(ig5)+
 	&				   (fload(1)*sinangle*xN6despl(xcoor,eleng)+
     &					fload(2)*cosangle*xN3despl(xcoor,eleng)+
     &					fload(3)*cosangle*dxN3despl(xcoor,eleng))
		else
				react(-ig5)=react(-ig5)-
 	&				   (fload(1)*sinangle*xN6despl(xcoor,eleng)+
     &					fload(2)*cosangle*xN3despl(xcoor,eleng)+
     &					fload(3)*cosangle*dxN3despl(xcoor,eleng))
		endif
c
c	Assembles the force corresponding to theta(2)
c
		if(ig6.gt.0) then
				eload(ig6)=eload(ig6)+
 	&				   (fload(2)*xN4despl(xcoor,eleng)+
     &					fload(3)*dxN4despl(xcoor,eleng))
		else
				react(-ig6)=react(-ig6)-
 	&				   (fload(2)*xN4despl(xcoor,eleng)+
     &					fload(3)*dxN4despl(xcoor,eleng))
		endif
	else
	  a=if
	  if=ir
        ir=a
	  a=im
	  im=is
	  is=a
	  goto 101 
	  endif

      return
      end
c
c--------------------------------------------------------------------------------------------
	subroutine bpress(ndime,nnodb,ngaub,nbpel,lbnod,press,
	&				  ldgof,eload,react,x,lnods,effort,nelem)
c--------------------------------------------------------------------------------------------
c
c	Evaluates the nodal forces due to boundary noermal presure and
c	assembles the correspondig component of the tangent matrix
c
c	ndime	--> number of dimensions
c	nnodb	--> number of nodes per boundary element
c	ngaub	--> number of Gauss points per boundary element
c	nbpel	--> number of boundary elements with applied pressure
c	elbdb	--> boundary elements information
c	lbnod	--> boundary elements connectivities
c	press	--> applied pressure
c	x		--> nodal coordinates
c	ldgof	--> degrees of freedom number of each node
c	eload	--> total load
c	react	--> reactions
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lbnod(nnodb,*),press(2,*),x(2,*),
	&		  ldgof(ndime,*),eload(*),react(*),lnods(nnodb,nelem),
	&		  effort(3,2,nelem)
			  

c
c	If no pressure elements are present returns
c
	if(nbpel.eq.0) return
c
c	Otherwise loops over the elements and Gauss points and Finds the 
c	value of the applied pressure
c
	do ie=1,nbpel
		epres1=press(1,ie)
		epres2=press(2,ie)
c	write (6,*) 'epres',epres
c	pause
c      
c	Find member length
c
	n1=lbnod(1,ie)
	n2=lbnod(2,ie)
	x1=x(1,n1)
	y1=x(2,n1)
	x2=x(1,n2)
	y2=x(2,n2)
c   	
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c	write (6,*) 'eleng',eleng
c	pause

c	
c	Finds and assembles the nodal froces
c
				call pforce(ndime,nnodb,ngaub,epres1,epres2,lbnod,
	&						ldgof,eload,react,eleng,ie,
     &						lnods,effort,nelem,x)
c		
	enddo
c
      return 
	end
c
c--------------------------------------------------------------------------------------------
	subroutine pforce(ndime,nnodb,ngaub,press1,press2,lbnod,ldgof,
	&				eload,react,eleng,ie,lnods,effort,nelem,x)
c--------------------------------------------------------------------------------------------
c
c	Evaluates the nodal forces due to boundary normal pressure and
c	assembles it into the residual and total nominal load vector
c
c	ndime	--> number of dimensions
c	nnodb	--> nuber of nodes per boundary element
c	press	--> applied pressure
c	elbdb	--> boundary elements information
c	lbnod	--> degrees of freedom number of each node
c	eload	--> total nominal load
c	react	--> reactions 
c	dxis	--> derivatives of geometry with respect isoparametric
c				coordinates
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lbnod(nnodb,*),lnods(2,nelem),effort(3,2,nelem),
	&		  ldgof(ndime,*),eload(*),react(*),x(2,*),xvect(2),
     &		  unit(2)
c
	ik=lbnod(1,ie)
	ip=lbnod(2,ie)

c	write (6,*) 'ip', ip, ik,eleng
c	pause
c
c	Finds which node is 1 in local numbering
c
c	Local numberig 1 corresponds to the low global numbering
c
	if (ik.gt.ip) then
	a=ik
	ik=ip
	ip=a
	endif
      x1=x(1,ik)
	y1=x(2,ik)
	x2=x(1,ip)
	y2=x(2,ip)
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c   	
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
	ig1=ldgof(1,ik)
	ig2=ldgof(2,ik)
	ig3=ldgof(3,ik)
	ig4=ldgof(1,ip)
	ig5=ldgof(2,ip)
	ig6=ldgof(3,ip)
c	write(6,*) 'if',if, im, ir, is
c	pause
c
c	We keep the nodal loads of each element due to a distributed load
c	in Global axes
c
c
	do it=1,nelem
		n1=lnods(1,it)
		n2=lnods(2,it)
	if(((n1.eq.ik).or.(n1.eq.ip)).and.((n2.eq.ik).or.(n2.eq.ip))) then
		do ig=1,ngaub
			effort(1,1,it)=effort(1,1,it)-
	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					cosangle*xN5despl(gauss(ig,ngaub),eleng)-
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					sinangle*xN1despl(gauss(ig,ngaub),eleng))
		enddo
		do ig=1,ngaub
			effort(2,1,it)=effort(2,1,it)-
 	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					sinangle*xN5despl(gauss(ig,ngaub),eleng)+
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					cosangle*xN1despl(gauss(ig,ngaub),eleng))	
		enddo
		do ig=1,ngaub
			effort(3,1,it)=effort(3,1,it)-
 	&					(xJacob(gauss(ig,ngaub),eleng)*press2*
     &					xN2despl(gauss(ig,ngaub),eleng))	
		enddo
		do ig=1,ngaub
			effort(1,2,it)=effort(1,2,it)-
 	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					cosangle*xN6despl(gauss(ig,ngaub),eleng)-
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					sinangle*xN3despl(gauss(ig,ngaub),eleng))
		enddo
		do ig=1,ngaub
			effort(2,2,it)=effort(2,2,it)-
 	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					sinangle*xN6despl(gauss(ig,ngaub),eleng)+
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					cosangle*xN3despl(gauss(ig,ngaub),eleng))	
		enddo
		do ig=1,ngaub
			effort(3,2,it)=effort(3,2,it)-
 	&					(xJacob(gauss(ig,ngaub),eleng)*press2*
     &					xN4despl(gauss(ig,ngaub),eleng))	
		enddo
	endif
	enddo

c
c	Node 1
c	Assembles the force corresponding to u(1)
c
		if(ig1.gt.0) then
			do ig=1,ngaub
				eload(ig1)=eload(ig1)+
 	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					cosangle*xN5despl(gauss(ig,ngaub),eleng)-
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					sinangle*xN1despl(gauss(ig,ngaub),eleng))
			enddo
c	write(6,*) 'eload(if)', eload(if), Jacob(gauss(ig),eleng), press 
c	write (6,*) N1despl(gauss(ig),eleng) 
c	pause
     		else
			do ig=1,ngaub
				react(-ig1)=react(-ig1)-
 	&		    		(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					cosangle*xN5despl(gauss(ig,ngaub),eleng)-
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					sinangle*xN1despl(gauss(ig,ngaub),eleng))
			enddo
		endif
c
c	Assembles the force corresponding to v(1)
c
		if(ig2.gt.0) then
			do ig=1,ngaub
				eload(ig2)=eload(ig2)+
  	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					sinangle*xN5despl(gauss(ig,ngaub),eleng)+
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					cosangle*xN1despl(gauss(ig,ngaub),eleng))
			enddo
		else
			do ig=1,ngaub
				react(-ig2)=react(-ig2)-
  	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					sinangle*xN5despl(gauss(ig,ngaub),eleng)+
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					cosangle*xN1despl(gauss(ig,ngaub),eleng))
			enddo
		endif
c
c	Assembles the force corresponding to theta(1)
c
		if(ig3.gt.0) then
			do ig=1,ngaub
				eload(ig3)=eload(ig3)+
  	&					(xJacob(gauss(ig,ngaub),eleng)*press2*
     &					xN2despl(gauss(ig,ngaub),eleng))
			enddo
		else
			do ig=1,ngaub
				react(-ig3)=react(-ig3)-
  	&					(xJacob(gauss(ig,ngaub),eleng)*press2*
     &					xN2despl(gauss(ig,ngaub),eleng))
			enddo
		endif

c
c	Node 2
c	Assembles the force corresponding to u(2)
c

   		if(ig4.gt.0) then
			do ig=1,ngaub
				eload(ig4)=eload(ig4)+
  	&				    (xJacob(gauss(ig,ngaub),eleng)*press1*
	&					cosangle*xN6despl(gauss(ig,ngaub),eleng)-
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					sinangle*xN3despl(gauss(ig,ngaub),eleng))
			enddo
		else
			do ig=1,ngaub
				react(-ig4)=react(-ig4)-
  	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					cosangle*xN6despl(gauss(ig,ngaub),eleng)-
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					sinangle*xN3despl(gauss(ig,ngaub),eleng))
			enddo
		endif
c
c	Assembles the force corresponding to v(2)
c
		if(ig5.gt.0) then
			do ig=1,ngaub
				eload(ig5)=eload(ig5)+
  	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					sinangle*xN6despl(gauss(ig,ngaub),eleng)+
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					cosangle*xN3despl(gauss(ig,ngaub),eleng))
			enddo
		else
			do ig=1,ngaub
				react(-ig5)=react(-ig5)-
  	&					(xJacob(gauss(ig,ngaub),eleng)*press1*
	&					sinangle*xN6despl(gauss(ig,ngaub),eleng)+
	&					xJacob(gauss(ig,ngaub),eleng)*press2*
     &					cosangle*xN3despl(gauss(ig,ngaub),eleng))
			enddo
		endif
c
c	Assembles the force corresponding to theta(1)
c
		if(ig6.gt.0) then
			do ig=1,ngaub
				eload(ig6)=eload(ig6)+
  	&					(xJacob(gauss(ig,ngaub),eleng)*press2*
     &					xN4despl(gauss(ig,ngaub),eleng))
			enddo
		else
			do ig=1,ngaub
				react(-ig6)=react(-ig6)-
  	&					(xJacob(gauss(ig,ngaub),eleng)*press2*
     &					xN4despl(gauss(ig,ngaub),eleng))
			enddo
		endif

      return
      end

c
c--------------------------------------------------------------------------------------------
	subroutine initno(ndgof,nprof,stifd,stifp,displ,icounter) 
c--------------------------------------------------------------------------------------------
c
c	Initialises nodal data such as initial coordinates, stiffnes
c	matrix and residual forces
c
c	ndgof	--> number of degrees of freedom
c	nprof	--> number of profile entries
c	stifd	--> diagonal of K
c	stifp	--> profile part of K
c	displ	--> displacement
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension stifd(*), stifp(*), displ(*) 
c
c	Initialises the siffness matrix to zero
c
	do ig=1,ndgof
		stifd(ig)=0.d0
	enddo
c
	if (icounter.eq.0) then
	do ig=1,ndgof
		displ(ig)=0.d0
	enddo
	endif
c
c	Initialises the siffnes matrix to zero
c
	do ip=1,nprof
		stifp(ip)=0.d0
	enddo
c
	return
	end
c
c--------------------------------------------------------------------------------------------
	subroutine stiffm(ndime,nnode,nelem,x,lnods,matno,
	&				  matyp,props,ldgof,kprof,stifd,stifp,displ,
     &				  xkelem,ndgof,nprof)
c--------------------------------------------------------------------------------------------
c
c	Initilises element data such as initial siffness matrix,
c	element loads,...
c
c	ndime	--> number of dimensions
c	nnode	--> number of nodes
c	ngaus	--> gravity vector
c	nelem	--> number of elements
c	gravt	--> gravity vector
c	x		--> nodal coordinates
c	eledb	--> element data base
c	lnods	--> element connectivities
c	matno	--> material number
c	matyp	--> materia type
c	props	--> material properties
c	ldgof	--> degree of freedom number
c	eload	--> nodal point and body forces
c	kprof	--> profile addresses
c	stifd	--> diagonal of K
c	stifp	--> profile part of K
c	vinc	--> jacobian at each gauss point
c	elecd	--> element cartesian derivatives at each Gauss point
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lnods(nnode,*),props(8,*),ldgof(ndime,*),
	&		  kprof(*),stifd(*),stifp(*),x(2,*),
     &		  matno(*),matyp(*),xj1(6,6),xjg(6,6),displ(*),
	&		  xkelem(6,6,nelem),xvect(2),unit(2)
      real alpha
c
c	Set values to 0
c
c	Most of these variables can be erased
c
		den1=0.d0
		den2=0.d0
		den3=0.d0
		den4=0.d0
		den5=0.d0
		den6=0.d0
		den7=0.d0
		den8=0.d0
		dena=0.d0
		denb=0.d0
		denc=0.d0
		dend=0.d0
		dene=0.d0
		denf=0.d0
		deng=0.d0
		denh=0.d0
	beta1=0.d0
	beta2=0.d0
	beta3=0.d0
	beta4=0.d0
	BBcoef=0.d0
	Bhatcoef=0.d0
	BBhatcoef=0.d0
		alpha=0.d0
		eleng=0.d0
		beta1=0.d0
		beta2=0.d0
		beta3=0.d0
c
c	Initialises the siffnes matrix to zero
c
	do ip=1,nprof
		stifp(ip)=0.d0
	enddo
c
	do ig=1,ndgof
		stifd(ig)=0.d0
	enddo
c

c
c	Loops over all the elements
c
	do ie=1,nelem
c
c	Initialize element matrix
c
		do iy=1,2*ndime
			do jz=1,2*ndime
				xjg(iy,jz)=0.d0
				xj1(iy,jz)=0.d0
			enddo
		enddo
c
	do i=1,2*ndime
		do j=1,2*ndime
			xkelem(i,j,ie)=0.d0
		enddo
	enddo
c
	 	im=matno(ie)
		mat=matyp(im)
		hi=props(1,im)
		fy=props(2,im)
		eps=props(3,im)
		bi=props(4,im)
	
c
c	Find member coordinates
c
	n1=lnods(1,ie)
	n2=lnods(2,ie)
	if (n1.gt.n2) then
	a=n1
	n1=n2
	n2=a
	endif
	x1=x(1,n1)
	y1=x(2,n1)
	x2=x(1,n2)
	y2=x(2,n2)
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c
c
c	Find the element length
c
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
c	Defining the velocity direccions
c
	ig1=ldgof(1,n1)
	ig2=ldgof(2,n1)
	ig3=ldgof(3,n1)
	ig4=ldgof(1,n2)
	ig5=ldgof(2,n2)
	ig6=ldgof(3,n2)
c
c	Realise velocities in local axes
c
		
		
		u1=0.d0
		if(ig1.gt.0) u1=displ(ig1)*cosangle+displ(ig2)*sinangle
		v1=0.d0
		if(ig2.gt.0) v1=-displ(ig1)*sinangle+displ(ig2)*cosangle
		theta1=0.d0
		if(ig3.gt.0) theta1=displ(ig3)
		u2=0.d0
		if(ig4.gt.0) u2=displ(ig4)*cosangle+displ(ig5)*sinangle
		v2=0.d0
		if(ig5.gt.0) v2=-displ(ig4)*sinangle+displ(ig5)*cosangle
		theta2=0.d0
		if(ig6.gt.0) theta2=displ(ig6)
c
c	Works out B(hat)*v
c
	Bhatv=(u2-u1)/eleng
c
c

c
c	Here we decide how many number of Gauss we use in the integration
c
	npgauss=2
c
	
      do i=1,npgauss
c
c	Works out B(gi)*v
c
		dena=d2xN1despl(gauss(i,npgauss),eleng,eleng)*v1
		denb=d2xN2despl(gauss(i,npgauss),eleng,eleng)*theta1
		denc=d2xN3despl(gauss(i,npgauss),eleng,eleng)*v2
		dend=d2xN4despl(gauss(i,npgauss),eleng,eleng)*theta2
		den1=dena+denb+denc+dend
c
	beta1=Bhatv/(den1+eps**2)
		
      if (beta1.ge.hi/2.d0) then
		beta1=hi/2.d0		
	endif
      if (beta1.le.-hi/2.d0) then
		beta1=-hi/2.d0		
	endif
c
c	other parameters
c
	a=hi/2.d0-beta1
	b=hi/2.d0+beta1
c
c	Points of integration of the area
c
	y1= (3.d0/4.d0)*(hi/2.d0)+beta1/4.d0
	y2= (1.d0/4.d0)*(hi/2.d0)+3.d0*beta1/4.d0
	y3=-(1.d0/4.d0)*(hi/2.d0)+3.d0*beta1/4.d0
	y4=-(3.d0/4.d0)*(hi/2.d0)+beta1/4.d0	
c
c	Stress extensions 
c
      e1=Bhatv-den1*y1
	e2=Bhatv-den1*y2
	e3=Bhatv-den1*y3
	e4=Bhatv-den1*y4

	beta2=1.d0/sqrt(e1**2+eps**2)+1.d0/sqrt(e2**2+eps**2)
	beta3=1.d0/sqrt(e3**2+eps**2)+1.d0/sqrt(e4**2+eps**2)
	beta4=y1/sqrt(e1**2+eps**2)+y2/sqrt(e2**2+eps**2)
	beta5=y3/sqrt(e3**2+eps**2)+y4/sqrt(e4**2+eps**2)
	beta6=(y1**2)/sqrt(e1**2+eps**2)+(y2**2)/sqrt(e2**2+eps**2)
	beta7=(y3**2)/sqrt(e3**2+eps**2)+(y4**2)/sqrt(e4**2+eps**2)

c
c	Works out the matrix coeficients
c
c	General coeficient for BB
c

	BBcoef=a*beta6+b*beta7
c
c	General coeficient for BBhat
c

	Bhatcoef=a*beta2+b*beta3
c
c	General coeficient for Bhatv
c
	BBhatcoef=-a*beta4-b*beta5
c
c	Works out the matrix factor for h/2(<=)abs(Bhatv/Bv)
c
c
		alpha=fy*bi*eleng/4.d0
	
c	Evaluate the local stiffnes matrix for Gauss 
c	No advantge of symetri
c
		xj1(1,1)=alpha*(Bhatcoef)/(eleng**2)
		xj1(1,2)=0.d0+alpha*BBhatcoef*
	&			 d2xN1despl(gauss(i,npgauss),eleng,eleng)/(-eleng)
		xj1(1,3)=0.d0+alpha*BBhatcoef*
	&			 d2xN2despl(gauss(i,npgauss),eleng,eleng)/(-eleng)
		xj1(1,4)=alpha*(Bhatcoef)/(-eleng**2)
		xj1(1,5)=0.d0+alpha*BBhatcoef*
	&			 d2xN3despl(gauss(i,npgauss),eleng,eleng)/(-eleng)
		xj1(1,6)=0.d0+alpha*BBhatcoef*
	&			 d2xN4despl(gauss(i,npgauss),eleng,eleng)/(-eleng)
		xj1(2,1)=xj1(1,2)
		xj1(2,2)=alpha*(d2xN1despl(gauss(i,npgauss),eleng,eleng)**2)*
	&			 BBcoef
		xj1(2,3)=alpha*d2xN1despl(gauss(i,npgauss),eleng,eleng)*
     &			 d2xN2despl(gauss(i,npgauss),eleng,eleng)*
     &			 BBcoef
		xj1(2,4)=0.d0+alpha*BBhatcoef*
	&			 d2xN1despl(gauss(i,npgauss),eleng,eleng)/(eleng)
		xj1(2,5)=alpha*d2xN1despl(gauss(i,npgauss),eleng,eleng)*
     &			 d2xN3despl(gauss(i,npgauss),eleng,eleng)*
	&			 BBcoef
		xj1(2,6)=alpha*d2xN1despl(gauss(i,npgauss),eleng,eleng)*
     &			 d2xN4despl(gauss(i,npgauss),eleng,eleng)*
	&			 BBcoef
		xj1(3,1)=xj1(1,3)
		xj1(3,2)=xj1(2,3)
		xj1(3,3)=alpha*(d2xN2despl(gauss(i,npgauss),eleng,eleng)**2)*
	&			 BBcoef
		xj1(3,4)=0.d0+alpha*BBhatcoef*
	&			 d2xN2despl(gauss(i,npgauss),eleng,eleng)/(eleng)
		xj1(3,5)=alpha*d2xN2despl(gauss(i,npgauss),eleng,eleng)*
	&			 d2xN3despl(gauss(i,npgauss),eleng,eleng)*
	&			 BBcoef
		xj1(3,6)=alpha*d2xN2despl(gauss(i,npgauss),eleng,eleng)*
	&			 d2xN4despl(gauss(i,npgauss),eleng,eleng)*
	&			 BBcoef
		xj1(4,1)=xj1(1,4)
		xj1(4,2)=xj1(2,4)
		xj1(4,3)=xj1(3,4)
		xj1(4,4)=alpha*(Bhatcoef)/(eleng**2)
		xj1(4,5)=0.d0+alpha*BBhatcoef*
	&			 d2xN3despl(gauss(i,npgauss),eleng,eleng)/(eleng)
		xj1(4,6)=0.d0+alpha*BBhatcoef*
	&			 d2xN4despl(gauss(i,npgauss),eleng,eleng)/(eleng)
		xj1(5,1)=xj1(1,5)
	 	xj1(5,2)=xj1(2,5)
		xj1(5,3)=xj1(3,5)
		xj1(5,4)=xj1(4,5)
		xj1(5,5)=alpha*(d2xN3despl(gauss(i,npgauss),eleng,eleng)**2)*
	&			 BBcoef
		xj1(5,6)=alpha*d2xN3despl(gauss(i,npgauss),eleng,eleng)*
	&			 d2xN4despl(gauss(i,npgauss),eleng,eleng)*
	&			 BBcoef
		xj1(6,1)=xj1(1,6)
	  	xj1(6,2)=xj1(2,6)
		xj1(6,3)=xj1(3,6)
		xj1(6,4)=xj1(4,6)
		xj1(6,5)=xj1(5,6)
		xj1(6,6)=alpha*(d2xN4despl(gauss(i,npgauss),eleng,eleng)**2)*
	&			 BBcoef



c	Add Gauss point matrices

		do iy=1,2*ndime
			do jz=1,2*ndime
				xjg(iy,jz)=xjg(iy,jz)+xj1(iy,jz)*coef(i,npgauss)
c	&					   coef(j,npgauss)
			enddo
		enddo
	
	enddo
c
c	We pass the element matrix to Global axes
c
		xj1(1,1)=(xjg(1,1)*cosangle-xjg(1,2)*sinangle)*cosangle-
	&			 (xjg(2,1)*cosangle-xjg(2,2)*sinangle)*sinangle
		xj1(1,2)=(xjg(1,1)*sinangle+xjg(1,2)*cosangle)*cosangle-
	&			 (xjg(2,1)*sinangle+xjg(2,2)*cosangle)*sinangle
		xj1(1,3)= xjg(1,3)*cosangle-xjg(2,3)*sinangle
		xj1(1,4)=(xjg(1,4)*cosangle-xjg(1,5)*sinangle)*cosangle-
	&			 (xjg(2,4)*cosangle-xjg(2,5)*sinangle)*sinangle
		xj1(1,5)=(xjg(1,4)*sinangle+xjg(1,5)*cosangle)*cosangle-
	&			 (xjg(2,4)*sinangle+xjg(2,5)*cosangle)*sinangle
		xj1(1,6)= xjg(1,6)*cosangle-xjg(2,6)*sinangle
		xj1(2,1)= xj1(1,2)
		xj1(2,2)=(xjg(1,1)*sinangle+xjg(1,2)*cosangle)*sinangle+
	&			 (xjg(2,1)*sinangle+xjg(2,2)*cosangle)*cosangle
		xj1(2,3)= xjg(1,3)*sinangle+xjg(2,3)*cosangle
		xj1(2,4)=(xjg(1,4)*cosangle-xjg(1,5)*sinangle)*sinangle+
	&			 (xjg(2,4)*cosangle-xjg(2,5)*sinangle)*cosangle
		xj1(2,5)=(xjg(1,4)*sinangle+xjg(1,5)*cosangle)*sinangle+
	&			 (xjg(2,4)*sinangle+xjg(2,5)*cosangle)*cosangle
		xj1(2,6)= xjg(1,6)*sinangle+xjg(2,6)*cosangle
		xj1(3,1)= xj1(1,3)
		xj1(3,2)= xj1(2,3)
		xj1(3,3)= xjg(3,3)
		xj1(3,4)= xjg(3,4)*cosangle-xjg(3,5)*sinangle
		xj1(3,5)= xjg(3,4)*sinangle+xjg(3,5)*cosangle
		xj1(3,6)= xjg(3,6)
		xj1(4,1)= xj1(1,4)
		xj1(4,2)= xj1(2,4)
		xj1(4,3)= xj1(3,4)
		xj1(4,4)=(xjg(4,4)*cosangle-xjg(4,5)*sinangle)*cosangle-
	&			 (xjg(5,4)*cosangle-xjg(5,5)*sinangle)*sinangle
		xj1(4,5)=(xjg(4,4)*sinangle+xjg(4,5)*cosangle)*cosangle-
	&			 (xjg(5,4)*sinangle+xjg(5,5)*cosangle)*sinangle
		xj1(4,6)= xjg(4,6)*cosangle-xjg(5,6)*sinangle
		xj1(5,1)= xj1(1,5)
	 	xj1(5,2)= xj1(2,5)
		xj1(5,3)= xj1(3,5)
		xj1(5,4)= xj1(4,5)
		xj1(5,5)=(xjg(4,4)*sinangle+xjg(4,5)*cosangle)*sinangle+
	&			 (xjg(5,4)*sinangle+xjg(5,5)*cosangle)*cosangle
		xj1(5,6)= xjg(4,6)*sinangle+xjg(5,6)*cosangle
		xj1(6,1)= xj1(1,6)
	  	xj1(6,2)= xj1(2,6)
		xj1(6,3)= xj1(3,6)
		xj1(6,4)= xj1(4,6)
		xj1(6,5)= xj1(5,6)
		xj1(6,6)= xjg(6,6)
c
c
c
c	We store the element matrix in global axes. It will be used to work
c	out the internal loads
c
c
	do iz=1,ndime*2
		do jz=1,ndime*2
			xkelem(iz,jz,ie)=xj1(iz,jz)
		enddo
	enddo
c
c
c	Find the global siffnes matrix	(assembled)
c
c	Loops over nodes and dimensions (rows)
c
	do in=1,nnode
		ip=lnods(in,ie)
		do jn=in,nnode
			jp=lnods(jn,ie)
c
c	Loops again over nodes and dimensions (columns)
c
			do id=1,ndime
				if=ldgof(id,ip)
				if(if.le.0) goto 10
					do jd=1,ndime
						if((in.eq.jn).and.(jd.lt.id)) goto 20
							jf=ldgof(jd,jp)
							if(jf.le.0) goto 20
c
c	Works out hte positions in the global matrix
c
							sum=0.d0
							ipos=(in-1)*ndime+id
							jpos=(jn-1)*ndime+jd
c
							sum=xj1(ipos,jpos)
c
c	Assembles sum in the right place. First case: diagonal term
c
							if(jf.eq.if) then
								stifd(if)= stifd(if)+sum
							else
c
c	Then the off-diagonal terms into the profile
c
							jc=max(jf,if)
							ir=min(jf,if)
							lp=kprof(jc)-jc+ir+1
							stifp(lp)=stifp(lp)+sum
						endif
   20					enddo
   10				enddo
   			enddo
		enddo
	enddo
	write(*,'(/)')
	write(*,*) stifp(1),stifp(2),stifp(3)
	write(*,'(/)')
	write(*,*) stifd(1),stifd(2),stifd(3)
	write(*,'(/)')
	do ig=1,ndgof
		displ(ig)=0.d0
	enddo
	return
c
	end

c
c------------------------------------------------------------------------------
      subroutine datri(al,au,ad,jp,neq,flg,jfile)                              
c------------------------------------------------------------------------------
c                                                                              
c.... triangular decomposition of a matrix stored in profile form              
c                                                                              
c.... input parameters                                                         
c         al(jp(neq)) - lower triangular part of matrix                        
c         au(jp(neq)) - upper part of triangular matrix                        
c         ad(neq)     - diagonals of triangular matrix                         
c         jp(neq)     - pointers to bottom of colums of al and au arrays       
c         neq         - number of equations to be solved                       
c         flg         - if true equations are unsymmetric                      
c                       if false equations are symmetric and calling           
c                       address of al may be same as that for au               
c                       (i.e., au and al share same memory)                    
c         jfile       - unit number for printed output of warning              
c                       messages.                                              
c.... output parameters                                                        
c         al(jp(neq)) - lower triangular factor of matrix                      
c         au(jp(neq)) - upper triangular factor of matrix                      
c         ad(neq)     - inverse of diagonal matrix in triangular factor        
c                                                                              
c------------------------------------------------------------------------------ 
      implicit real*8 (a-h,o-z)
      logical flg
      dimension al(*),au(*),ad(*),jp(*) 
      data tol /1.e-7/
c 
c.... n.b.  tol should be set to approximate half-word precision. 
c.... loop through the columns to perform the triangular decomposition 
c 
      jd = 1 
      do j = 1,neq 
         jr = jd + 1 
         jd = jp(j) 
         jh = jd - jr 
         if(jh.gt.0) then 
            is = j - jh 
            ie = j - 1 
c 
c.... if diagonal is 0.0 compute a norm for singularity test 
c 
            if(ad(j).eq.0.0) call datest(au(jr),jh,daval) 
            do i = is,ie 
               jr = jr + 1 
               id = jp(i) 
               ih = min0(id-jp(i-1),i-is+1) 
               if(ih.gt.0) then 
                  jrh = jr - ih 
                  idh = id - ih + 1 
                  au(jr) = au(jr) - dot(au(jrh),al(idh),ih) 
                  if(flg) al(jr) = al(jr) - dot(al(jrh),au(idh),ih) 
               endif 
            enddo
         endif 
c 
c.... reduce the diagonal 
c 
         if(jh.ge.0) then 
            dd = ad(j) 
            jr = jd - jh 
            jrh = j - jh - 1 
            call dredu(al(jr),au(jr),ad(jrh),jh+1,flg  ,ad(j)) 
c 
c.... check for possible errors and print warnings 
c 
            if(abs(ad(j)).lt.tol*abs(dd))  write(jfile,2000) j 
            if(dd.lt.0.0.and.ad(j).gt.0.0) write(jfile,2001) j 
            if(dd.gt.0.0.and.ad(j).lt.0.0) write(jfile,2001) j 
            if(ad(j) .eq.  0.0)            write(jfile,2002) j
c 
c.... complete rank test for a 0.0 diagonal case 
c 
            if(dd.eq.0.0.and.jh.gt.0) then 
               if(abs(ad(j)).lt.tol*daval)   write(jfile,2003) j 
            endif 
         endif 
c 
c.... store reciprocal of diagonal 
c 
         if(ad(j).ne.0.0) ad(j) = 1./ad(j)  
      enddo 
      return 
c  
 2000 format(' Solver warning: loss of at least 7 digits in', 
     & ' reducing diagonal n. ',i5) 
 2001 format(' Solver warning: sign of diagonal changed when', 
     & ' reducing equation',i5) 
 2002 format(' Solver warning: reduced diagonal is zero for', 
     & ' equation',i5) 
 2003 format(' Solver warning: rank failure for zero unreduced', 
     & ' diagonal in equation',i5) 
      end 
c  
c------------------------------------------------------------------------------
      subroutine dasol(al,au,ad,b,u,jp,neq,jfile, energy)                        
c------------------------------------------------------------------------------
c                                                                              
c.... solution of equations stored in profile form                             
c.... coefficient matrix must be decomposed into its triangular                
c.... factors using datri before using dasol.                                  
c                                                                              
c.... input parameters                                                         
c         al(jp(neq)  - lower triangular factor of matrix                      
c         au(jp(neq)  - upper triangular factor of matrix                      
c                       (au and al have same calling address for               
c                        symmetric matrices)                                   
c         ad(neq)     - reciprocal of diagonal of triangular factor            
c         b(neq)      - right hand side vector in equations                    
c         jp(neq)     - pointer array to bottom of columns of al and au        
c         neq         - number of equations to be solved                       
c         jfile       - unit number for printed warning message.               
c         energy      - energy norm for equations (rhs * soln)                 
c                                                                              
c.... output parameter                                                         
c         u(neq)      - solution of equations                                  
c                                                                              
c------------------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension al(*),au(*),ad(*),b(*),jp(*),u(*)
c 
c.... find the first non zero entry in the right hand side 
c 
      do is = 1,neq 
         u(is)=b(is)
        if(b(is).ne.0.0) go to 200 
      enddo 
      write(jfile,2000) 
      return
c 
c.... reduce the right hand side 
c 
 200  if(is.lt.neq) then 
         do j = is+1,neq 
            jr = jp(j-1) 
            jh = jp(j) - jr
            u(j)=b(j) 
            if(jh.gt.0) then 
               u(j) = u(j) - dot(al(jr+1),u(j-jh),jh) 
            endif 
         enddo 
      endif 
c 
c.... multiply by inverse of diagonal elements 
c 
      energy = 0.0 
      do j = is,neq 
         bd = u(j) 
         u(j) = u(j)*ad(j) 
         energy = energy + bd*u(j) 
      enddo 
c 
c.... backsubstitution 
c 
      if(neq.gt.1) then 
         j = neq
         do while(j.gt.1) 
            jr = jp(j-1) 
            jh = jp(j) - jr 
            if(jh.gt.0) then 
               call colred(au(jr+1),u(j),jh, u(j-jh)) 
            endif 
            j = j - 1 
         enddo  
      endif 
      return
c 
 2000 format(' Solver warning: zero right-hand-side vector') 
      end 
c  
c------------------------------------------------------------------------------
      subroutine datest(au,jh,daval)                                           
c------------------------------------------------------------------------------
c                                                                              
c.... test for rank                                                            
c                                                                              
c.... inputs                                                                   
c                                                                              
c         au(j)   -    column of unreduced elements in array                
c         jh      -    number of elements in column                            
c                                                                              
c.... outputs                                                                  
c                                                                              
c         daval   -    sum of absolute values                                  
c                                                                              
c------------------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension au(jh) 
c
      daval = 0.0 
      do 100 j = 1,jh 
         daval = daval + abs(au(j)) 
 100  continue 
      return 
      end 
c 
c------------------------------------------------------------------------------
      function dot(a,b,n)                                                    
c------------------------------------------------------------------------------
c                                                                              
c.... vector dot product                                                       
c                                                                              
c.... input parameters                                                         
c         a(n),b(n) - two vectors                                              
c         n         - length of vectors                                        
c.... ouput parameter                                                          
c         dot       - dot product of a and b                                   
c                                                                              
c------------------------------------------------------------------------------
c 
      implicit real*8 (a-h,o-z)
      dimension a(*),b(*) 
      dot = 0.0 
      do i = 1,n 
         dot = dot + a(i)*b(i) 
      enddo 
      return 
      end 
c 
c------------------------------------------------------------------------------
      subroutine dredu(al,au,ad,jh,flg ,dj)                                   
c------------------------------------------------------------------------------
c                                                                              
c.... reduce diagonal element in triangular decomposition                      
c                                                                              
c.... input parameters                                                         
c         au(jh)   - column of upper triangular part of matrix                 
c         al(jh)   - row of lower triangular part of matrix                    
c         ad(jh)   - reciprocal of diagonals in triangular factors             
c         jh       - number of terms in vectors                                
c         flg      - if .true.  equations are unsymmetric                      
c                    if .false. equations are symmetric                        
c         dj       - diagonal in matrix to be factored                         
c.... output parameter                                                         
c         dj       - reduced diagonal of factor                                
c                                                                              
c------------------------------------------------------------------------------
c 
      implicit real*8 (a-h,o-z)
      logical flg 
      dimension al(jh),au(jh),ad(jh) 
c
      do j = 1,jh 
         ud = au(j)*ad(j) 
         dj = dj - al(j)*ud 
         au(j) = ud 
      enddo
c 
c.... finish computation of column of al for unsymmetric matrices 
c 
      if(flg) then 
         do j = 1,jh 
            al(j) = al(j)*ad(j)  
         enddo 
      endif 
      return 
      end 
c  
c------------------------------------------------------------------------------
      subroutine colred(au,xj,nn, b)                                           
c------------------------------------------------------------------------------
c                                                                              
c.... columnwise reduction for backsubstitution                                
c                                                                              
c.... input parameters                                                         
c         au(nn)  - column of upper triangular factor                          
c         xj      - solution of j-th equation                                  
c         nn      - number of terms in current column                          
c.... output parameter                                                         
c         b(nn)   - vector being modified to solution vector                   
c                                                                              
c------------------------------------------------------------------------------
c
      implicit real*8 (a-h,o-z)
      dimension au(*),b(*)
c 
      do n = 1,nn 
        b(n) = b(n) - au(n)*xj 
      enddo
      return 
      end 
c
c-----------------------------------------------------------------------
	subroutine displace(ndgof,displ,eload,gamma,nnode,xkelem,nelem,
	&					lnods,ldgof,ndime,R,iter,dispprev,
     &					rdespl)
c--------------------------------------------------------------------------------------------
c
c	Works out the elemental displacements  and the load multiplier
c
c--------------------------------------------------------------------------------------------

c
	implicit real*8 (a-h,o-z)
	dimension displ(ndgof),eload(ndgof)
	dimension lnods(2,*),ldgof(ndime,*),f(ndgof),
	&		  xkelem(6,6,nelem),dispprev(ndgof)
c
c	Initial dispprev
c
      if (iter.eq.1) then
		do ig=1,ndgof
			dispprev(ig)=0.d0
		enddo
	endif
c
c	Find new gamma
c

	gamma=0.d0
	do ig=1,ndgof
		gamma=gamma+eload(ig)*displ(ig)
	enddo

c
	gamma=1.d0/gamma
c
c	Find displacements scaling by gamma
c
	do ig=1,ndgof
		displ(ig)=gamma*displ(ig)
	enddo
c
c	Convergence in displacements
c
	do ig=1,ndgof
		dispprev(ig)=displ(ig)-dispprev(ig)

	enddo
	xnum=0.d0
	xden=0.d0
	rdespl=0.d0
      xnum=sqrt(dot(dispprev,dispprev,ndgof))
	xden=sqrt(dot(displ,displ,ndgof))
	rdespl=abs(xnum/xden)
c
c	Find de value of gamma*//sqrt(dot(b,b))//
c
	rund=0.d0
c      rund=abs(sqrt(dot(eload,eload,ndgof)))

      rund=gamma*abs(sqrt(dot(eload,eload,ndgof)))
c
	call prodmatvec(nelem,ndime,lnods,nnode,ldgof,ndgof,displ,xkelem,
	&				f)
	do ig=1,ndgof
		f(ig)=f(ig)-gamma*eload(ig)
	enddo
c
c	Final relative error
c
	R=R/rund
	R=xnum/xden
	write (6,*) 'R',R
c
c	Displacement convergence
c
	do ig=1,ndgof
		dispprev(ig)=displ(ig)
	enddo
	return
	end
c
c--------------------------------------------------------------------------------------------
	subroutine eff(ndime,nelem,lnods,ldgof,xkelem,effort,displ,
	&			   gamma,pdisp,nplsi,x,press,lbnod,effortlocal,
     &				nbpel,effort3,npoin,icode,equil,xloadNx,yloadNy)
c--------------------------------------------------------------------------------------------
c
c	Works out the internal loads in the elements
c
c	   effort=[F1 F2|.....|F1 F2]
c			   elem 1      elem n
c
c	where Fi=(fi) column of fi,Mi 
c			 (Mi)
c
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lnods(2,*),ldgof(ndime,*),xkelem(6,6,nelem),
	&          pdisp(*),effort(3,2,nelem),x(2,*),press(2,*),
     &		  displ(*),v(6),lbnod(2,nbpel),
	&		  effort3(3,2,nelem),icode(npoin),unit(2),xvect(2),
	&		  effortlocal(3,2,nelem),effort3local(3,2,nelem)
c
c
c	Nodal forces due to distributed and point loads
c	We delette the point nodal forces
c

      do ie=1,nelem

c	Finds the nodal connectivity of element ie
 		n1=lnods(1,ie)
		n2=lnods(2,ie)
		if (n1.gt.n2) then
			a=n1
			n1=n2
			n2=a
		endif
c
c	Finds the numberig of the degrees of freedom (v,theta)
c	of the two nodes of the element
c
c	It is used to know de displacements correspondig to the nodes
c	of the element
c
		ig1=ldgof(1,n1)
		ig2=ldgof(2,n1)
		ig3=ldgof(3,n1)
		ig4=ldgof(1,n2)
		ig5=ldgof(2,n2)
		ig6=ldgof(3,n2)
c
c	Finds the displacements of the nodes
c
c	Finds the nodal forces of the nodes due to 
c	distributed and point loads
c	
c	Always it awares the local numbering (1,2)
c
   		if (ig1.gt.0) then
			v(1)=displ(ig1)
		else
			v(1)=pdisp(-ig1)
		endif
		if (ig2.gt.0) then
			v(2)=displ(ig2)
		else
			v(2)=pdisp(-ig2)
		endif
		if (ig3.gt.0) then
			v(3)=displ(ig3)
		else
			v(3)=pdisp(-ig3)
		endif
		if (ig4.gt.0) then
			v(4)=displ(ig4)
		else
			v(4)=pdisp(-ig4)
		endif
		if (ig5.gt.0) then
			v(5)=displ(ig5)
		else
			v(5)=pdisp(-ig5)
		endif
		if (ig6.gt.0) then
			v(6)=displ(ig6)
		else
			v(6)=pdisp(-ig6)
		endif
c	write(6,*) ig1,ig2,ig3,ig4,ig5,ig6
c     write(6,*) v(1),v(2),v(3),v(4),v(5),v(6)
c	pause
c
c	Works out the efforts in global axes
c	
	
		do n=1,ndime
			do m=1,2*ndime
			effort(n,1,ie)=effort(n,1,ie)+xkelem(n,m,ie)*v(m)/gamma	
			effort(n,2,ie)=effort(n,2,ie)+xkelem(n+ndime,m,ie)*
	&						v(m)/gamma
			enddo
 		enddo
		  
c      
c	Find member length
c
	x1=x(1,n1)
	y1=x(2,n1)
	x2=x(1,n2)
	y2=x(2,n2)
	unit(1)=1.d0
	unit(2)=0.d0
	xvect(1)=x2-x1
	xvect(2)=y2-y1
	angle=0.d0
c
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng
c
c	Works out the efforts in local axes
c
	do i=1,2
		effortlocal(1,i,ie)=effort(1,i,ie)*cosangle+
	&						effort(2,i,ie)*sinangle
		effortlocal(2,i,ie)=-effort(1,i,ie)*sinangle+
	&						effort(2,i,ie)*cosangle
		effortlocal(3,i,ie)=effort(3,i,ie)
	enddo
c
	do i=1,2
		effort3local(1,i,ie)=effort3(1,i,ie)*cosangle+
	&						effort3(2,i,ie)*sinangle
		effort3local(2,i,ie)=-effort3(1,i,ie)*sinangle+
	&						effort3(2,i,ie)*cosangle
		effort3local(3,i,ie)=effort3(3,i,ie)
	enddo
c   	
c
c	It does not work for a general case....may be removed
c
c	Element equilibrium in local axes
c
c	First detects if the element has pressure
c
c	Then keeps the value of the pressure
c
c	write(6,*)'nplsi',nplsi
c	pause
c
      if (nbpel.gt.0) then
		do i=1,nbpel
		n3=lbnod(1,i)
		n4=lbnod(2,i)
c	write(6,*) 'n1',n1,n2,n3,n4
c	pause
	if(((n1.eq.n3).or.(n1.eq.n4)).and.((n2.eq.n3).or.(n2.eq.n4))) then
			if (nplsi.eq.0) then
c	if (nbpel.eq.10) then
c		write(6,*) effort3(1,1,ie),effort3(1,2,ie),eleng,press(ie),
c	&	gamma
c	pause
c	endif
		residNx=(effortlocal(1,1,ie)+effortlocal(1,2,ie)+press(1,i)*
	&	eleng+effort3local(1,1,ie)+effort3local(1,2,ie))*gamma
c		
		residNy=(effortlocal(2,1,ie)+effortlocal(2,2,ie)+press(2,i)*
	&	eleng+effort3local(2,1,ie)+effort3local(2,2,ie))*gamma
c
		residmome=(effortlocal(3,1,ie)+effortlocal(3,2,ie)+
	&	eleng*effortlocal(2,2,ie)+press(2,i)*eleng*eleng/2.+
     &	effort3local(3,1,ie)+effort3local(3,2,ie)+
     &	effort3local(2,2,ie)*eleng)*gamma
			endif			
		goto 69
	else
		if(i.eq.nbpel) then
			if(nplsi.eq.0) then
		residNx=(effortlocal(1,1,ie)+effortlocal(1,2,ie)+
	&			effort3local(1,1,ie)+effort3local(1,2,ie))*gamma
c		
		residNy=(effortlocal(2,1,ie)+effortlocal(2,2,ie)+
	&			effort3local(2,1,ie)+effort3local(2,2,ie))*gamma
c
		residmome=(effortlocal(3,1,ie)+effortlocal(3,2,ie)+
	&	eleng*effortlocal(2,2,ie)+effort3local(3,1,ie)+
     &	effort3local(3,2,ie)+effort3local(2,2,ie)*eleng)*gamma
			endif
		endif
	endif
   		enddo
	else
		if (nplsi.eq.0) then
		residNx=(effortlocal(1,1,ie)+effortlocal(1,2,ie)+
	&	effort3local(1,1,ie)+effort3local(1,2,ie))*gamma
c		
		residNy=(effortlocal(2,1,ie)+effortlocal(2,2,ie)+
	&			effort3local(2,1,ie)+effort3local(2,2,ie))*gamma
c
		residmome=(effortlocal(3,1,ie)+effortlocal(3,2,ie)+
	&	eleng*effortlocal(2,2,ie)+effort3local(3,1,ie)+
     &	effort3local(3,2,ie)+effort3local(2,2,ie)*eleng)*gamma
c
		endif
      endif	
	
c
   69	enddo

c	Global equilibrium Loads (Always in Global axes)
c
c	Reactions
c
	resload=0.d0
c	resmome=0.d0
c
      do i=1,npoin
		if (icode(i).gt.0) then
			do j=1,nelem
				n5=lnods(1,j)
				n6=lnods(2,j)
				if (n5.gt.n6) then
					a=n5
					n5=n6
					n6=a
				endif
				if (n5.eq.i) then					
					resloadNx=resloadNx+effort(1,1,j)*gamma+
	&						effort3(1,1,j)*gamma
					resloadNy=resloadNy+effort(2,1,j)*gamma+
	&						effort(2,1,j)*gamma
				endif
				if (n6.eq.i) then
					resloadNx=resloadNx+effort(1,2,j)*gamma+
 	&						effort3(1,2,j)*gamma
					resloadNy=resloadNy+effort(2,2,j)*gamma+
	&						effort(2,2,j)*gamma
				endif
			enddo
		endif
	enddo

c
c	External actions
c
c	Distributed load
	extload=0.d0
c
	do i=1,nbpel
		n5=lbnod(1,i)
		n6=lbnod(2,i)
		if (n5.gt.n6) then
			a=n5
			n5=n6
			n6=a
		endif
		x1=x(1,n5)
		y1=x(2,n5)
		x2=x(1,n6)
		y2=x(2,n6)
c   	
		eleng=sqrt((x2-x1)**2+(y2-y1)**2)
		extloadNx=extloadNx+press(1,i)*eleng*gamma
		extloadNy=extloadNy+press(2,i)*eleng*gamma
	enddo
	equil=0.d0
c	
      equilNx=extloadNx+resloadNx+xloadNx*gamma
	equilNy=extloadNy+resloadNy+yloadNy*gamma
c
	return
	end
c
c--------------------------------------------------------------------------------------------
	subroutine output(nnode,npoin,nelem,displ,ldgof,ndime,
	&				  icode,lnods,ndgof,matno)
    
c--------------------------------------------------------------------------------------------
c
c	Writes elemental data to a file
c
	implicit real*8 (a-h,o-z)
	dimension lnods(nnode,*),icode(*),matno(*),displ(ndgof),
	&		  d(3),ldgof(ndime,*)
c
c	Writes the node number, DOF and vertical displacement
c
	write(2,*) npoin
	do	ip=1,npoin
		do id=1,ndime
			ig=ldgof(id,ip)
			d(id)=displ(ig)
		enddo
		write(2,*) ip,icode(ip),0.0,d(1),0.0
	enddo
c
c	Writes the node number and Euler Bending Angles
c
	do ip=1,npoin
		do id=1,ndime
			ig=ldgof(id,ip)
			d(id)=displ(ig)
		enddo
	write(2,*) ip,0.0,d(2),0.0
	enddo
c
c	Writes the nmber of elements,material and nodal connectivities
c
	write(2,*) nelem
	do ie=1,nelem
		write(2,*) ie,matno(ie),(lnods(in,ie),in=1,nnode)
	enddo

c	
      return
c
	end

c--------------------------------------------------------------------------------------------
	function xN1despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out shape function N1 related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
c	Shape function at xd
c
	xN1despl=1.+1./4.*(xd-2.)*(1.+xd)**2
      return 				 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function dxN1despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out dN1/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
c
	dxN1despl=3.*(1.+xd)*(xd-1.)/(2.*eleng)
      return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function d2xN1despl(xd,eleng,beta)
c--------------------------------------------------------------------------------------------
c
c	Work out d2N1/dx2 related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c

c	none division by 0 control
      if (eleng.eq.0.d0) then
	d2xN1despl=0.d0
	return
	endif
c
	w=beta*(1.d0+xd)/2.d0
	d2xN1despl=12.d0*w/(eleng**3)-6.d0/(eleng**2)
c
      return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function xN2despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out shape function N2 related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c	Shape function at xd
c
	xN2despl=eleng*((1.+xd)*(1.-xd)**2)/8.
	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function dxN2despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out dN2/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
      dxN2despl=(xd-1.)*(1.+3.*xd)/4.
	return 
	end
c--------------------------------------------------------------------------------------------
c
c
c--------------------------------------------------------------------------------------------
	function d2xN2despl(xd,eleng,beta)
c--------------------------------------------------------------------------------------------
c
c	Work out dN2/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
c	none division by 0 control
      if (eleng.eq.0.d0) then
	d2xN1despl=0.d0
	return
	endif
c
c
	w=beta*(1.d0+xd)/2.d0
      d2xN2despl=-4.d0/eleng+6.d0*w/(eleng**2)
	return 
	end
c--------------------------------------------------------------------------------------------
c
c
c--------------------------------------------------------------------------------------------
	function xN3despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out shape function N3 related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c	Shape function at xd
c
c
	xN3despl=-(1./4.)*(xd-2.)*(1.+xd)**2
	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function dxN3despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out dN3/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
	dxN3despl=3.*(1.+xd)*(1.-xd)/(2.*eleng)

	return 
	end
c--------------------------------------------------------------------------------------------
c
c
c--------------------------------------------------------------------------------------------
	function d2xN3despl(xd,eleng,beta)
c--------------------------------------------------------------------------------------------
c
c	Work out dN3/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
c	none division by 0 control
      if (eleng.eq.0.d0) then
	d2xN1despl=0.d0
	return
	endif
c
	w=beta*(1.d0+xd)/2.d0
	d2xN3despl=-12.d0*w/(eleng**3)+6.d0/(eleng**2)
c
	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function xN4despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out shape function N4 related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c	Shape function at xd
c
c
	xN4despl=eleng*((-1.+xd)*(1.+xd)**2)/8.
	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function dxN4despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out dN4/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
      dxN4despl=(xd+1.)*(-1.+3.*xd)/4.

	return 
	end
c--------------------------------------------------------------------------------------------
c
c
c--------------------------------------------------------------------------------------------
	function d2xN4despl(xd,eleng,beta)
c--------------------------------------------------------------------------------------------
c
c	Work out dN4/dx related to desplacements     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
c	none division by 0 control
      if (eleng.eq.0.d0) then
	d2xN1despl=0.d0
	return
	endif
c
	w=beta*(1.d0+xd)/2.d0
	d2xN4despl=-2.d0/eleng+6.*w/(eleng**2)

	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function xN5despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out shape function N5 related to desplacement u1    	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
	xN5despl=(1.d0-xd)/2.d0
	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function xN6despl(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Work out shape function N5 related to desplacements u2     	
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c
	xN6despl=(1.d0+xd)/2.d0
	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function xJacob(xd,eleng)
c--------------------------------------------------------------------------------------------
c
c	Jacobian function of the change of variable x---->xd
c
c	Dimension 1
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
c
c	Change of variable	
c
	w=(eleng/2.)*(1.+xd)
c
c	Jacob function at xd
c
	xJacob=eleng/2.
	
      return
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	function gauss(i,npgauss)
c--------------------------------------------------------------------------------------------
c
c	Gauss' points: element 2 Gauss' points
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)

	if (npgauss.eq.2) then
		if(i.eq.1) then
			gauss=-1.d0/(sqrt(3.d0))
		else
			gauss=1.d0/(sqrt(3.d0))
		endif
	endif
	if (npgauss.eq.3) then
		if(i.eq.1) then
			gauss=-sqrt(3.d0)/sqrt(5.d0)
		endif
		if(i.eq.2) then
			gauss=0.d0
		endif
		if(i.eq.3) then
			gauss=sqrt(3.d0)/sqrt(5.d0)
		endif
	endif
	if (npgauss.eq.4) then
		if(i.eq.1) then
			gauss=-0.86113631
		endif
		if(i.eq.2) then
			gauss=-0.33998104
		endif
		if(i.eq.3) then
			gauss=0.33998104
		endif
		if(i.eq.4) then
			gauss=0.86113631
		endif  
      endif
	if (npgauss.eq.10) then
		if(i.eq.1) then
			gauss=-0.97390653
		endif
		if(i.eq.2) then
			gauss=-0.86506337
		endif
		if(i.eq.3) then
			gauss=-0.67940957
		endif
		if(i.eq.4) then
			gauss=-0.43339539
		endif  
     		if(i.eq.5) then
			gauss=-0.14887434
		endif
		if(i.eq.6) then
			gauss=0.14887434
		endif
		if(i.eq.7) then
			gauss=0.43339539
		endif
		if(i.eq.8) then
			gauss=0.67940957
		endif
		if(i.eq.9) then
			gauss=0.86506337
		endif
		  if(i.eq.10) then
			gauss=0.97390653
		endif  
      endif
	if (npgauss.eq.16) then
		if(i.eq.1) then
			gauss=-0.98940093499165
		endif
		if(i.eq.2) then
			gauss=-0.94457502307323
		endif
		if(i.eq.3) then
			gauss=-0.86563120238783
		endif
		if(i.eq.4) then
			gauss=-0.75540440835500
		endif  
     		if(i.eq.5) then
			gauss=-0.61787624440264
		endif
		if(i.eq.6) then
			gauss=-0.45801677765723
		endif
		if(i.eq.7) then
			gauss=-0.28160355077926
		endif
		if(i.eq.8) then
			gauss=-0.09501250983764
		endif
		if(i.eq.9) then
			gauss=0.09501250983764
		endif
		  if(i.eq.10) then
			gauss=0.28160355077926
		endif  
		if(i.eq.11) then
			gauss=0.45801677765723
		endif
		if(i.eq.12) then
			gauss=0.61787624440264
		endif
		if(i.eq.13) then
			gauss=0.75540440835500
		endif
		if(i.eq.14) then
			gauss=0.86563120238783
		endif  
     		if(i.eq.15) then
			gauss=0.94457502307323
		endif
		if(i.eq.16) then
			gauss=0.98940093499165
		endif
	endif      
	return
	end		
c
c--------------------------------------------------------------------------------------------
	function coef(i,npgauss)
c--------------------------------------------------------------------------------------------
c
c	Gauss Legendre integration coeficients
c--------------------------------------------------------------------------------------------
	Implicit real*8 (a-h,o-z)
c
	if (npgauss.eq.2) then
		coef=1.d0
	endif
c
      if (npgauss.eq.3) then
		if(i.eq.1) then
			coef=5.d0/9.d0
		endif
		if(i.eq.2) then
			coef=8.d0/9.d0
		endif
		if(i.eq.3) then
			coef=5.d0/9.d0
		endif
	endif
c
      if (npgauss.eq.4) then
		if(i.eq.1) then
			coef=0.3478548451
		endif
		if(i.eq.2) then
			coef=0.6521451549
		endif
		if(i.eq.3) then
			coef=0.6521451549
		endif
		if(i.eq.4) then
			coef=0.3478548451
		endif
	endif

c
	if (npgauss.eq.10) then
		if(i.eq.1) then
			coef=0.06667134
		endif
		if(i.eq.2) then
			coef=0.14945135
		endif
		if(i.eq.3) then
			coef=0.21908636
		endif
		if(i.eq.4) then
			coef=0.26926672
		endif  
		if(i.eq.5) then
			coef=0.29552422
		endif
		if(i.eq.6) then
			coef=0.29552422
		endif
		if(i.eq.7) then
			coef=0.26926672
		endif
		if(i.eq.8) then
			coef=0.21908636
		endif  
		if(i.eq.9) then
			coef=0.14945135
		endif
		if(i.eq.10) then
			coef=0.06667134
		endif
	endif
c
	if (npgauss.eq.16) then
		if(i.eq.1) then
			coef=0.02715245941175
		endif
		if(i.eq.2) then
			coef=0.06225352393865
		endif
		if(i.eq.3) then
			coef=0.09515851168249
		endif
		if(i.eq.4) then
			coef=0.12462897125553
		endif  
		if(i.eq.5) then
			coef=0.14959598881658
		endif
		if(i.eq.6) then
			coef=0.16915651939500
		endif
		if(i.eq.7) then
			coef=0.18260341504492
		endif
		if(i.eq.8) then
			coef=0.18945061045507
		endif  
		if(i.eq.9) then
			coef=0.18945061045507
		endif
		if(i.eq.10) then
			coef=0.18260341504492
		endif
		if(i.eq.11) then
			coef=0.16915651939500
		endif
		if(i.eq.12) then
			coef=0.14959598881658
		endif
		if(i.eq.13) then
			coef=0.12462897125553
		endif
		if(i.eq.14) then
			coef=0.09515851168249
		endif  
		if(i.eq.15) then
			coef=0.06225352393865
		endif
		if(i.eq.16) then
			coef=0.02715245941175
		endif
	endif
	return
	end
c
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	subroutine gradcon(ndgof,lnods,nnode,ldgof,ndime,nelem,
	&					eload,xkelem,xo)	
c--------------------------------------------------------------------------------------------
c
c	Works out the solution of linear sistem by using the Conjugate Grad method
c
c	we have to adabt this method for this special kind of matrix
c
c			IN THE FUTURE
c
c--------------------------------------------------------------------------------------------
c
	implicit real*8 (a-h,o-z)
	dimension lnods(nnode,*),ldgof(ndime,*)
	dimension eload(ndgof),xkelem(6,6,nelem)
	dimension xo(ndgof),ro(ndgof),po(ndgof),q(ndgof)

c
c	Initial guess xo
c
	do ig=1,ndgof
		xo(ig)=1.d0
	enddo
c
c	Iteration number
c
	kk=0
c
c	Tol
c
	tolgrad=0.5e-8
c
c	Works out K(v)*v
c
	call prodmatvec(nelem,ndime,lnods,nnode,ldgof,ndgof,xo,xkelem,ro)
c
c	Works out  K(v)*v-*b
c
	do i=1,ndgof
		ro(i)=ro(i)-eload(i)
	enddo
c
c	Works out po
c
	do i=1,ndgof
		po(i)=ro(i)
	enddo
c
c	Iteration procedure
c
	graderr=0.d0
      do iter=1,200000
c
c	Product matrix*vector q=K*p
c	
	call prodmatvec(nelem,ndime,lnods,nnode,ldgof,ndgof,po,xkelem,q)
c
		alpha=-dot(po,ro,ndgof)/dot(po,q,ndgof)
c
c	Works out new x
c
		do i=1,ndgof
			xo(i)=xo(i)+alpha*po(i)
		enddo
c
c	Works out new ro
c
c	Works out K(v)*v
c
	call prodmatvec(nelem,ndime,lnods,nnode,ldgof,ndgof,xo,xkelem,ro)
c
c	Works out  K(v)*v-*b
c
		do i=1,ndgof
			ro(i)=ro(i)-eload(i)
		enddo
c
c	Works out Beta
c
		beta=-dot(ro,q,ndgof)/dot(po,q,ndgof)
c
c	Works out new po
c
		do i=1,ndgof
			po(i)=ro(i)+beta*po(i)
		enddo
c
c
	graderr=abs(sqrt(dot(ro,ro,ndgof))/sqrt(dot(eload,eload,ndgof)))
c	
      if (tolgrad.gt.graderr)then
c		do l=1,ndgof
c			write(6,*) 'xo',xo(l)
c			pause
c		enddo
c	write (6,*) 'iter',iter
c	pause
		go to 1111
	endif

		kk=kk+1
c	write (6,*) kk
c	pause
	if (iter.eq.2000000)then
	stop
	endif
	enddo
c
c
 1111	return 
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	subroutine prodmatvec(nelem,ndime,lnods,nnode,ldgof,ndgof,
	&					  po,xkelem,t)
c--------------------------------------------------------------------------------------------
c
c	Works out the product K(v)*v
c
c
c	Using only xkelem
c
c--------------------------------------------------------------------------------------------
c
	Implicit real*8 (a-h,o-z)
	dimension lnods(nnode,*),ldgof(ndime,*),po(ndgof)
	dimension xkelem(6,6,nelem),t(ndgof),v(6)

c	write (6,*) 'k',kk
	do i=1,ndgof
		t(i)=0.d0
	enddo
c	
	do ig=1,nelem
		n1=lnods(1,ig)
		n2=lnods(2,ig)
		if (n1.gt.n2) then
			a=n1
			n1=n2
			n2=a
		endif
c
c	Local node 1 : degrees of freedom
c
		ig1=ldgof(1,n1)
		ig2=ldgof(2,n1)
		ig3=ldgof(3,n1)
c
c	Local node 2 : degrees of freedom
c
		ig4=ldgof(1,n2)
		ig5=ldgof(2,n2)
		ig6=ldgof(3,n2)
c
c	Select displacements degrees of freedom
c
		v(1)=0.d0
		if(ig1.gt.0) then
			v(1)=po(ig1)
		endif
		v(2)=0.d0
		if(ig2.gt.0) then
			v(2)=po(ig2)
		endif
		v(3)=0.d0
		if(ig3.gt.0) then
			v(3)=po(ig3)
		endif
		v(4)=0.d0
		if(ig4.gt.0) then
			v(4)=po(ig4)
		endif
		v(5)=0.d0
		if(ig5.gt.0) then
			v(5)=po(ig5)
		endif
		v(6)=0.d0
		if(ig6.gt.0) then
			v(6)=po(ig6)
		endif
c
c	Work out load K*v
c
     		if (ig1.gt.0) then
			do k=1,2*ndime
				t(ig1)=t(ig1)+xkelem(1,k,ig)*v(k)
			enddo
		endif
     		if (ig2.gt.0) then
			do k=1,2*ndime
				t(ig2)=t(ig2)+xkelem(2,k,ig)*v(k)
			enddo
		endif
     		if (ig3.gt.0) then
			do k=1,2*ndime
				t(ig3)=t(ig3)+xkelem(3,k,ig)*v(k)
			enddo
		endif
     		if (ig4.gt.0) then
			do k=1,2*ndime
				t(ig4)=t(ig4)+xkelem(4,k,ig)*v(k)
			enddo
		endif
     		if (ig5.gt.0) then
			do k=1,2*ndime
				t(ig5)=t(ig5)+xkelem(5,k,ig)*v(k)
			enddo
		endif
     		if (ig6.gt.0) then
			do k=1,2*ndime
				t(ig6)=t(ig6)+xkelem(6,k,ig)*v(k)
			enddo
		endif		
	enddo
c
	return
	end
c--------------------------------------------------------------------------------------------
c
c--------------------------------------------------------------------------------------------
	subroutine contrib(ie,matno,matyp,props,lnods,npoin,x,ldgof,displ,
	&				   pdisp,gap,gammalower,effort4,effort,ndime,cont,
     &		           eleng,n1,n2,x1,y1,sinangle,cosangle)

c--------------------------------------------------------------------------------------------
c
c	Works out the contribution to the gap of each element
c	in order to work out which element has to be refined
c
c
c	
c
c--------------------------------------------------------------------------------------------
c
	Implicit real*8 (a-h,o-z)
	dimension  matno(*),matyp(*),props(8,*),lnods(2,*),x(2,*)
	dimension ldgof(ndime,npoin),effort4(3,2,*),effort(3,2,*),
	&		  unit(2),xvect(2),displ(*),pdisp(*)
      real alpha 
c
c	Set values to 0
c
		den1=0.d0
		den2=0.d0
		den3=0.d0
		den5=0.d0
		dena=0.d0
		denb=0.d0
		denc=0.d0
		dend=0.d0
		alpha=0.d0
		eleng=0.d0
		en=0.d0
		cont=0.d0
		beta1=0.d0
		beta2=0.d0
		omega1=0.d0
		omega2=0.d0
		xini=0.d0
		xend=0.d0
c
	 	im=matno(ie)
		mat=matyp(im)
		hi=props(1,im)
		fy=props(2,im)
		eps=props(3,im)
		bi=props(4,im)
		

c
c	Find member coordinates
c
	n1=lnods(1,ie)
	n2=lnods(2,ie)
	if (n1.gt.n2) then
	a=n1
	n1=n2
	n2=a
	endif
	x1=x(1,n1)
	y1=x(2,n1)
	x2=x(1,n2)
	y2=x(2,n2)
	xvect(1)=x2-x1
	xvect(2)=y2-y1
c
c
c	Find the element length
c
	eleng=sqrt((x2-x1)**2+(y2-y1)**2)
c
	angle=0.d0
	unit(1)=1.d0
	unit(2)=0.d0
	angle=acos(dot(unit,xvect,2)/eleng)
c	
      sinangle=(y2-y1)/eleng
	cosangle=(x2-x1)/eleng

c	write(*,*)'eleng=',eleng
c	pause
c
c	Defining the velocity direccions
c
	ig1=ldgof(1,n1)
	ig2=ldgof(2,n1)
	ig3=ldgof(3,n1)
	ig4=ldgof(1,n2)
	ig5=ldgof(2,n2)
	ig6=ldgof(3,n2)

c
c
c	Realize velocities in local axes
c
	
		u1=0.d0
		if(ig1.gt.0) u1=displ(ig1)*cosangle+displ(ig2)*sinangle
		v1=0.d0
		if(ig2.gt.0) v1=-displ(ig1)*sinangle+displ(ig2)*cosangle
		theta1=0.d0
		if(ig3.gt.0) theta1=displ(ig3)
		u2=0.d0
		if(ig4.gt.0) u2=displ(ig4)*cosangle+displ(ig5)*sinangle
		v2=0.d0
		if(ig5.gt.0) v2=-displ(ig4)*sinangle+displ(ig5)*cosangle
		theta2=0.d0
		if(ig6.gt.0) theta2=displ(ig6)
	
c
c	Works out B(hat)*v
c
	Bhatv=(u2-u1)/eleng
c
c	Works out B*v
c
	den1=0.d0
	dena=0.d0
	denb=0.d0
	denc=0.d0
	dend=0.d0
	alpha=0.d0
	
      npgauss=2
	beta1=eleng
	beta2=0.d0
	beta3=0.d0
	do i=1,npgauss
c
	do j=1,npgauss

		dena=d2xN1despl(gauss(i,npgauss),eleng,eleng)*v1
		denb=d2xN2despl(gauss(i,npgauss),eleng,eleng)*theta1
		denc=d2xN3despl(gauss(i,npgauss),eleng,eleng)*v2
		dend=d2xN4despl(gauss(i,npgauss),eleng,eleng)*theta2
		den1=dena+denb+denc+dend
c
c
	beta1=Bhatv/(den1+eps**2)
	
      if (beta1.ge.hi/2.d0) then
		beta1=hi/2.d0
	endif
	if (beta1.le.-hi/2.d0)then
		beta1=-hi/2.d0
	endif

	den2=((beta1+hi/2.d0)*
	&	 gauss(j,npgauss)+(beta1-hi/2.d0))/2.d0
c
      den3=Bhatv-(den1)*(den2)
c
      den4=(1.d0/2.d0)*(beta1+hi/2.d0)
c
	den5=((-beta1+hi/2.d0)*
	&	 gauss(j,npgauss)+(beta1+hi/2.d0))/2.d0
c
      den6=Bhatv-(den1)*(den5)
c
      den7=(1.d0/2.d0)*(-beta1+hi/2.d0)

	beta2=den4*sqrt(den3**2)
	beta3=den7*sqrt(den6**2)
	
     	alpha=alpha+coef(i,npgauss)*coef(j,npgauss)*(beta2+beta3)
c
c	write (6,*) 'den1',den1,Bhatv
	enddo
	enddo
c
c	Works out the plastic energy due to the element ie
c
	
	en=fy*bi*eleng*alpha/2.d0
	sumen=sumen+en
c	write (6,*) 'en',en,sumen
c	pause		

c
c	Works out the external energy (in global axes: this axes in this case are not important)
c
		dena=0.d0
		denb=0.d0
		dene=0.d0
		denf=0.d0
		deng=0.d0
		denh=0.d0
		den2=0.d0
c
		if (ig1.gt.0) then
			dene=(effort4(1,1,ie)+effort(1,1,ie))*displ(ig1)
		else
			dene=(effort4(1,1,ie)+effort(1,1,ie))*pdisp(-ig1)
		endif
		if (ig2.gt.0) then
			denf=(effort4(2,1,ie)+effort(2,1,ie))*displ(ig2)
		else
			denf=(effort4(2,1,ie)+effort(2,1,ie))*pdisp(-ig2)
		endif
		if (ig3.gt.0) then
			deng=(effort4(3,1,ie)+effort(3,1,ie))*displ(ig3)
			else
			deng=(effort4(3,1,ie)+effort(3,1,ie))*pdisp(-ig3)
		endif
		if (ig4.gt.0) then
			denh=(effort4(1,2,ie)+effort(1,2,ie))*displ(ig4)
		else
			denh=(effort4(1,2,ie)+effort(1,2,ie))*pdisp(-ig4)
		endif
		if (ig5.gt.0) then
			dena=(effort4(2,2,ie)+effort(2,2,ie))*displ(ig5)
			else
			dena=(effort4(2,2,ie)+effort(2,2,ie))*pdisp(-ig5)
		endif
		if (ig6.gt.0) then
			denb=(effort4(3,2,ie)+effort(3,2,ie))*displ(ig6)
		else
			denb=(effort4(3,2,ie)+effort(3,2,ie))*pdisp(-ig6)
		endif
c
	den2=dene+denf+deng+denh+dena+denb
c
c	Works out the decision parameter: contribution of the ie element
c	to gamma dividend by the average contribution av
c
		cont=(en-den2*gammalower)/gap
		write (6,*) 'contrib',cont
		pause
	return
	end
